#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2dragon4uri.py">
#<abstract4xi abstract = "shoot dragon activating DummyProcess4Xi processes (threads) with target functions to check local hyperlinks in HTML files"/>
#<refer4xi reference = "automate2ref4uri.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
#
# 1) go to Studio4Xi in commmand mode
#     > go3studio4fb    <-- Python 3 version of Studio4Xi in Fastblack workstation (fb)
#     > go3studio4riika <-- Python 3 version of Studio4Xi in Riika
#     nb: you could use the same go2studio4xi-command in all workstations just defining root! 
#  
# 2) prepare your test data keeping in mind the following:
#    ~ small is beautiful - you naturally will have some broken links, but its worth it! 
#    ~ big is bad - you'll end up analysing too much data just because you tried perfect input!
#    ~ web is your final goal as content location, NOT your local workstation!
#    ~ browsers do have bug - do NOT trust them to handle your local URIs properly!
#     
# 3) see version4xi.py and look for automate2ref4uri.py, there you see test data locations
#
# 4) see settings in this module BEFORE running it and keep in mind the following:
#    ~ URI tests are fast, if you test URI's do NOT test URLs at the same time! 
#    ~ URL tests are slow, Python URL lib has bugs, do NOT test them at the same time with URIs!
#    ~ no passwords are beiing given for URL tests, therefore you may get warnings
#
#    ========================                            
#    ack2debug4dragon    = True  # <-- True, normally                    / False, embedded trace only
#    ack2urltest4dragon  = True  # <-- True, once URI test passed        / False, if URI test first
#    ack2uricheck4dragon = True  # <-- True, normally for URI tests      / False, only wrong URI references reported
#    ack2urlwarn4dragon  = True  # <-- True, normally                    / False, no report about skipped one
#    ======================== 
#
# 5) make sure you have defined all domains, see kbdomain2uri4dragon
#
# 6) decide your focus domain, see kbfocus2uri4dragon
#
# 7) check where you have your saying to this module, search - USER
#
# 8) make sure you have this module's backups BEFORE your modifications!
#
# 9) view uri2dragon4yo.html with you browser and editor after running shoot2dragon4uri5test.py
#    - use macro with editor to find [NACK] in uri2dragon4yo.html, then find the corresponding line in the module verified
#
# 10) view index2studio4xi.html, specially after running automate2ref4uri.py
#     - click 70
#     - select index2studio4xi.html#URI2TEST4YO           <-- view URI tests!
#     -        index2studio4xi.html#URL2TEST4YO           <-- view URL tests!
#     -        index2studio4xi.html#SYSTEMTESTING2URI4YO  <-- update!
#     -        index2studio4xi.html#WEB2TEST4YO           <-- view tests in web (FTP upload needed)!
#  
# TIPS:
# a) you can focus to one folder at a time by setting kbfocus2uri4dragon dictionary!
#    + other folders can serve as content providers to be referred by the folder in focus!
# b) shoot2dragon4uri.py is used by automate2ref4uri.py to generate modules shoot2xxxxxxxx4uri.py where xxxxxxxx = {0,1 ... 33}
#    ~ if you both ack2debug4dragon and ack2urltest4dragon equal to True
#      - big trace
#      - long run
#      + allows you to check URIs and URLs while permitting you do other tasks
#        and using available CPU and hard disk resources you have!  
# c) distributing data to several had disks has its advantages
#
# d) run shoot2dragon4uri5test.py and keep your focus data in test2dragon with all necessary domains
#
# e) automate2ref4uri.py and have you test data distributed between test2one ... test2thirtythree
#    being aware that while testing URI it speeds up your tests while testing URL
#    you'll have to have several concurrent internet connections and OS capable to handle them! 
# f) pay attention to your test data, its valuable, keep tested in master2test folder, 
#    keep the previous test2dragon content in test2thirtytwo, FTP upload test data and
#    run tests in several workstations
#  
#"
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2dragon4uri']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import itertools
import logging 
import os
import signal
import sys
import threading                
from urllib import request
import weakref
import _thread
import _winapi

#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2dragon4uri: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2dragon4uri: *** error: from process4xi import Process4Xi ***")    
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2debug4dragon
global ack2relative4dragon
global ack2href4dragon
global ack2html4dragon
global ack2http4dragon

global ack2urltest4dragon
global ack2uricheck4dragon

global ack2urlwarn4dragon

global count2ackuri4dragon
global count2nackuri4dragon
global count2ackurl4dragon
global count2nackurl4dragon

global count2found4dragon
global count2passed4dragon

global count2relative4dragon

global dragon2ref4uri

global end2weblink4dragon

global fileobject2stat4dragon
global fileobject2target4dragon
global fileobject2verify4dragon   



global kb2omit4dragon

global kb2find4dragon
global key2find4dragon
global keys2find4dragon
global keys2profile4dragon
global key2profile4dragon
global keys2hyper4dragon
global keys2ext4dragon

global kb2badhyper4dragon
global keys2badhyper4dragon

global kbdomain2uri4dragon
global keys2domain2uri4dragon

global kbfocus2uri4dragon
global keys2focus2uri4dragon

global kbwalk2uri4dragon
global keys2walk2uri4dragon

global len2webpattern4dragon


global pattern2relative4dragon
global pattern2onerelative4dragon
global pattern2tworelative4dragon
global pattern2threerelative4dragon
global pattern2fourrelative4dragon
global pattern2fiverelative4dragon
global pattern2sixrelative4dragon
global pattern2sevenrelative4dragon
global pattern2eightrelative4dragon

global pattern2skip4dragon
global pattern2skipone4dragon
global pattern2skiptwo4dragon
global pattern2skipthree4dragon
global pattern2skipfour4dragon
global pattern2skipfive4dragon
global pattern2skipsix4dragon
global pattern2skipseven4dragon
global pattern2skipeight4dragon

global pattern2href4dragon
global pattern2inside4dragon
global pattern2ext4dragon
global pattern2hyper4dragon

global profile2fetch4dragon

global total2ackuri4dragon
global total2nackuri4dragon
global total2ackurl4dragon
global total2nackurl4dragon

global webpattern2level4dragon
global winpattern2level4dragon

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
 
# ===============================
# TEST SETTINGS - USER
# ===============================                        
#                           # Note1: verify both URI and URL after having verified URL (you may have accidentally modified an URI)!
#                           -------------------------------------------------------------------------------------------------------
ack2debug4dragon    = False # <-- True, when testing small sets  /False, embedded and special trace only
ack2uricheck4dragon = True  # <-- True, URI tests                /False, only wrong URI references reported
ack2urltest4dragon  = True  # <-- True, URL tests (takes time!)  /False, when only URI tests are done
ack2urlwarn4dragon  = False # <-- True, skipped ones reported    /False, normally
#                           -------------------------------------------------------------------------------------------------------
                            # Note2: set ack2uricheck4dragon True, when verifying URL of large content such as sense - checking URI gives time for system to handle next URL request!

# ===============================
# DEFAULTS - PROGRAM
# ===============================
ack2relative4dragon = False
ack2href4dragon     = False
ack2html4dragon     = False
ack2http4dragon     = False  
                            
count2ackuri4dragon  = 0
count2nackuri4dragon = 0
count2ackurl4dragon  = 0
count2nackurl4dragon = 0
count2found4dragon   = 0
count2passed4dragon  = 0
count2relative4dragon       = 0

dragon2ref4uri  = VersionKB4Xi['dragon2ref4uri']

end2weblink4dragon = '.html"'

fileobject2stat4dragon = None
fileobject2target4dragon = None
fileobject2verify4dragon = None   


# ===============================
# DUMMY - DON'T TOUCH
# ===============================
kb2find4dragon = {}
key2find4dragon = 0
rare2find4dragon = "ala-koskaan-loyda-tata"
kb2find4dragon[1]='<a href="..'             
kb2find4dragon[2]=rare2find4dragon                   
kb2find4dragon[3]=rare2find4dragon                  
kb2find4dragon[4]=rare2find4dragon                      
kb2find4dragon[5]=rare2find4dragon         
kb2find4dragon[6]=rare2find4dragon          
kb2find4dragon[7]=rare2find4dragon           
kb2find4dragon[8]=rare2find4dragon   
keys2find4dragon = kb2find4dragon.keys()

# ===============================
# NOT BE VERIFIED URLs
# ===============================
kb2badhyper4dragon     = {}
kb2badhyper4dragon   [1] = 'ftp://'
kb2badhyper4dragon   [2] = 'ftps://'
kb2badhyper4dragon   [3] = 'mailto:'
keys2badhyper4dragon = kb2badhyper4dragon.keys() 

kbdomain2uri4dragon  = {}
# ===============================
# DOMAINS (nb:decide focus later!)
# ===============================
kbdomain2uri4dragon [1]   = 'a'  #[ACK] 
kbdomain2uri4dragon [2]   = 'b'  #[ACK]
kbdomain2uri4dragon [3]   = 'c'  #[ACK]
kbdomain2uri4dragon [4]   = 'd'  #[ACK]  
kbdomain2uri4dragon [5]   = 'e'  #[ACK]
kbdomain2uri4dragon [6]   = 'f'  #[ACK]
kbdomain2uri4dragon [7]   = 'g'  #[ACK]
kbdomain2uri4dragon [8]   = 'h'  #[ACK] 
kbdomain2uri4dragon [9]   = 'i'  #[ACK] 
kbdomain2uri4dragon [10]  = 'j' #[ACK] 
kbdomain2uri4dragon [11]  = 'k' #[ACK] 
kbdomain2uri4dragon [12]  = 'l' #[ACK]
kbdomain2uri4dragon [13]  = 'm' #[ACK]
kbdomain2uri4dragon [14]  = 'n' #[ACK]
kbdomain2uri4dragon [15]  = 'o' #[ACK]
kbdomain2uri4dragon [16]  = 'p' #[ACK]
kbdomain2uri4dragon [17]  = 'q' #[ACK] 
kbdomain2uri4dragon [18]  = 'r' #[ACK]
kbdomain2uri4dragon [19]  = 's' #[ACK]
kbdomain2uri4dragon [20]  = 't' #[ACK]
kbdomain2uri4dragon [21]  = 'u' #[ACK]
kbdomain2uri4dragon [22]  = 'v' #[ACK]
kbdomain2uri4dragon [23]  = 'w' #[ACK] 
kbdomain2uri4dragon [24]  = 'x' #[ACK] 
kbdomain2uri4dragon [25]  = 'y' #[ACK]
kbdomain2uri4dragon [26]  = 'z' #[ACK]  

# kbdomain2uri4dragon [1]  = 'sense'      #[ACK] 
# kbdomain2uri4dragon [2]  = 'bp'         #[ACK]
# kbdomain2uri4dragon [3]  = 'brand'      #[ACK]
# kbdomain2uri4dragon [4]  = 'design'     #[ACK]  
# kbdomain2uri4dragon [5]  = 'nda'        #[ACK]
# kbdomain2uri4dragon [6]  = 'ss'         #[ACK]
# kbdomain2uri4dragon [7]  = 'vc'         #[ACK]
# kbdomain2uri4dragon [8]  = 'web'        #[ACK] 
# kbdomain2uri4dragon [9]  = 'spec'       #[ACK] 
# kbdomain2uri4dragon [10]  = 'sw4xi'     #[ACK] 
# kbdomain2uri4dragon [11]  = 'scope4xi'  #[ACK] 
# kbdomain2uri4dragon [12]  = 'studio4xi' #[ACK]
# kbdomain2uri4dragon [13]  = 'temp'      #[ACK] 

keys2domain2uri4dragon = kbdomain2uri4dragon.keys() 

kbfocus2uri4dragon  = {}
# ===============================
# FOCUS DOMAINS - USER'S CHOICE
# ===============================
kbfocus2uri4dragon [1]   = 'a'  #[ACK] 
kbfocus2uri4dragon [2]   = 'b'  #[ACK]
kbfocus2uri4dragon [3]   = 'c'  #[ACK]
kbfocus2uri4dragon [4]   = 'd'  #[ACK]  
kbfocus2uri4dragon [5]   = 'e'  #[ACK]
kbfocus2uri4dragon [6]   = 'f'  #[ACK]
kbfocus2uri4dragon [7]   = 'g'  #[ACK]
kbfocus2uri4dragon [8]   = 'h'  #[ACK] 
kbfocus2uri4dragon [9]   = 'i'  #[ACK] 
kbfocus2uri4dragon [10]  = 'j' #[ACK] 
kbfocus2uri4dragon [11]  = 'k' #[ACK] 
kbfocus2uri4dragon [12]  = 'l' #[ACK]
kbfocus2uri4dragon [13]  = 'm' #[ACK]
kbfocus2uri4dragon [14]  = 'n' #[ACK]
kbfocus2uri4dragon [15]  = 'o' #[ACK]
kbfocus2uri4dragon [16]  = 'p' #[ACK]
kbfocus2uri4dragon [17]  = 'q' #[ACK] 
kbfocus2uri4dragon [18]  = 'r' #[ACK]
kbfocus2uri4dragon [19]  = 's' #[ACK]
kbfocus2uri4dragon [20]  = 't' #[ACK]
kbfocus2uri4dragon [21]  = 'u' #[ACK]
kbfocus2uri4dragon [22]  = 'v' #[ACK]
kbfocus2uri4dragon [23]  = 'w' #[ACK] 
kbfocus2uri4dragon [24]  = 'x' #[ACK] 
kbfocus2uri4dragon [25]  = 'y' #[ACK]
kbfocus2uri4dragon [26]  = 'z' #[ACK] 

keys2focus2uri4dragon = kbfocus2uri4dragon.keys() 

# -----------------------------------------------------------------------------------------
# PICK THE ONES(S) - TIP: consider clusters i.e. related to each others or to your purposes
# -----------------------------------------------------------------------------------------
# kbfocus2uri4dragon [1]  = 'sense'      #[ACK] 
# kbfocus2uri4dragon [2]  = 'bp'         #[ACK]
# kbfocus2uri4dragon [3]  = 'brand'      #[ACK]
# kbfocus2uri4dragon [4]  = 'design'     #[ACK]  
# kbfocus2uri4dragon [5]  = 'nda'        #[ACK]
# kbfocus2uri4dragon [6]  = 'ss'         #[ACK]
# kbfocus2uri4dragon [7]  = 'vc'         #[ACK]
# kbfocus2uri4dragon [8]  = 'web'        #[ACK]
# kbfocus2uri4dragon [9]  = 'spec'       #[ACK]
# kbfocus2uri4dragon [10]  = 'sw4xi'     #[ACK]
# kbfocus2uri4dragon [11]  = 'scope4xi'  #[ACK]
# kbfocus2uri4dragon [12]  = 'studio4xi' #[ACK]

# kbfocus2uri4dragon [13]  = 'icewaves'  #[ACK] <--  only by itself and skipping complicated menu scripts; see kb2omit4dragon  
# kbfocus2uri4dragon [14]  = 'master'    #[NACK] <-- Plone type - do NOT take!


# ===============================
# EXTENSIONS - PROGRAM
# ===============================
pattern2ext4dragon = {}
pattern2ext4dragon  [1]  = '.HTML"'
pattern2ext4dragon  [2]  = '.html"'
pattern2ext4dragon  [3]  = '.HTM"'
pattern2ext4dragon  [4]  = '.htm"'
pattern2ext4dragon  [5]  = '.PDF"'
pattern2ext4dragon  [6]  = '.pdf"'
pattern2ext4dragon  [7]  = '.eml"'
pattern2ext4dragon  [8]  = '.EML"'
pattern2ext4dragon  [9]  = '.doc"'
pattern2ext4dragon  [10] = '.DOC"'
pattern2ext4dragon  [11] = '.txt"'
pattern2ext4dragon  [12] = '.TXT"'
pattern2ext4dragon  [13] = '.msg"'
pattern2ext4dragon  [14] = '.MSG"'
pattern2ext4dragon  [15] = '.rtf"'
pattern2ext4dragon  [16] = '.RTF"'
pattern2ext4dragon  [17] = '.xml"'
pattern2ext4dragon  [18] = '.XML"'
pattern2ext4dragon  [19] = '.tar"'
pattern2ext4dragon  [20] = '.TAR"'
pattern2ext4dragon  [21] = '.mp3"'
pattern2ext4dragon  [22] = '.MP3"'
pattern2ext4dragon  [23] = '.wav"'
pattern2ext4dragon  [24] = '.WAV"'
pattern2ext4dragon  [25] = '.swf"'
pattern2ext4dragon  [26] = '.SWF"'
pattern2ext4dragon  [27] = '.3ds"'
pattern2ext4dragon  [28] = '.3DS"'
pattern2ext4dragon  [29] = '.max"'
pattern2ext4dragon  [30] = '.MAX"'
pattern2ext4dragon  [31] = '.jpg"'
pattern2ext4dragon  [32] = '.JPG"'
pattern2ext4dragon  [33] = '.png"'
pattern2ext4dragon  [34] = '.PNG"'
pattern2ext4dragon  [35] = '.psd"'
pattern2ext4dragon  [36] = '.PSD"'
pattern2ext4dragon  [37] = '.tif"'
pattern2ext4dragon  [38] = '.TIF"'
pattern2ext4dragon  [39] = '.svg"'
pattern2ext4dragon  [40] = '.SVG"'
pattern2ext4dragon  [41] = '.xlr"'
pattern2ext4dragon  [42] = '.XLR"'
pattern2ext4dragon  [43] = '.xls"'
pattern2ext4dragon  [44] = '.XLS"'
pattern2ext4dragon  [45] = '.gpx"'
pattern2ext4dragon  [46] = '.GPX"'
pattern2ext4dragon  [47] = '.ico"'
pattern2ext4dragon  [48] = '.ICO"'
pattern2ext4dragon  [49] = '.rar"'
pattern2ext4dragon  [50] = '.RAR"'
pattern2ext4dragon  [51] = '.zip"'
pattern2ext4dragon  [52] = '.ZIP"'
pattern2ext4dragon  [53] = '.cpp"'
pattern2ext4dragon  [54] = '.CPP"'
pattern2ext4dragon  [55] = '.py"'
pattern2ext4dragon  [56] = '.PY"'
pattern2ext4dragon  [57] = '.java"'
pattern2ext4dragon  [58] = '.JAVA"'
pattern2ext4dragon  [59] = '.sh"'
pattern2ext4dragon  [60] = '.SH"'
keys2ext4dragon = pattern2ext4dragon.keys() 

# ===============================
# PATTERNS - PROGRAM
# ===============================
pattern2hyper4dragon     = {}
pattern2hyper4dragon [1] = 'http://'
pattern2hyper4dragon [2] = 'https://'
pattern2hyper4dragon [3] = 'ftp://'
pattern2hyper4dragon [4] = 'ftps://'
pattern2hyper4dragon [5] = 'mailto:'
                  
keys2hyper4dragon = pattern2hyper4dragon.keys()

pattern2href4dragon     = '<a href="'

pattern2relative4dragon        = ''
pattern2onerelative4dragon     = '../'
pattern2tworelative4dragon     = '../../'
pattern2threerelative4dragon   = '../../../'
pattern2fourrelative4dragon    = '../../../../'
pattern2fiverelative4dragon    = '../../../../../'
pattern2sixrelative4dragon     = '../../../../../../'
pattern2sevenrelative4dragon   = '../../../../../../../'
pattern2eightrelative4dragon   = '../../../../../../../../'

pattern2skip4dragon      = '../'
pattern2skipone4dragon   = '../sense/'
pattern2skiptwo4dragon   = '../../sense/'
pattern2skipthree4dragon = '../../../sense/'
pattern2skipfour4dragon  = '../../../../sense/'
pattern2skipfive4dragon  = '../../../../../sense/'
pattern2skipsix4dragon   = '../../../../../../sense/'
pattern2skipseven4dragon = '../../../../../../../sense/'
pattern2skipeight4dragon = '../../../../../../../../sense/'

pattern2inside4dragon   = '<a href="#'

webpattern2level4dragon = '//'
winpattern2level4dragon = '\\'
len2webpattern4dragon = len(webpattern2level4dragon) #2
len2winpattern4dragon = len(winpattern2level4dragon) #1

# ===============================
# WALKS - PROGRAM
# ===============================
kbwalk2uri4dragon  = {}
kbwalk2uri4dragon [1] = '../../../../../../../../sense/'
kbwalk2uri4dragon [2] = '../../../../../../../sense/'
kbwalk2uri4dragon [3] = '../../../../../../sense/'
kbwalk2uri4dragon [4] = '../../../../../sense/'
kbwalk2uri4dragon [5] = '../../../../sense/'
kbwalk2uri4dragon [6] = '../../../sense/'
kbwalk2uri4dragon [7] = '../../sense/'
kbwalk2uri4dragon [8] = '../sense/'
kbwalk2uri4dragon [9] = '../../../../../../../../spec/'
kbwalk2uri4dragon [10] = '../../../../../../../spec/'
kbwalk2uri4dragon [11] = '../../../../../../spec/'
kbwalk2uri4dragon [12] = '../../../../../spec/'
kbwalk2uri4dragon [13] = '../../../../spec/'
kbwalk2uri4dragon [14] = '../../../spec/'
kbwalk2uri4dragon [15] = '../../spec/'
kbwalk2uri4dragon [16] = '../spec/'
kbwalk2uri4dragon [17] = '../../../../../../../../brand/'
kbwalk2uri4dragon [18] = '../../../../../../../brand/'
kbwalk2uri4dragon [19] = '../../../../../../brand/'
kbwalk2uri4dragon [20] = '../../../../../brand/'
kbwalk2uri4dragon [21] = '../../../../brand/'
kbwalk2uri4dragon [22] = '../../../brand/'
kbwalk2uri4dragon [23] = '../../brand/'
kbwalk2uri4dragon [24] = '../brand/'
kbwalk2uri4dragon [25] = '../../../../../../../../design/'
kbwalk2uri4dragon [26] = '../../../../../../../design/'
kbwalk2uri4dragon [27] = '../../../../../../design/'
kbwalk2uri4dragon [28] = '../../../../../design/'
kbwalk2uri4dragon [29] = '../../../../design/'
kbwalk2uri4dragon [30] = '../../../design/'
kbwalk2uri4dragon [31] = '../../design/'
kbwalk2uri4dragon [32] = '../design/'    
kbwalk2uri4dragon [33] = '../../../../../../../../web/'
kbwalk2uri4dragon [34] = '../../../../../../../web/'
kbwalk2uri4dragon [35] = '../../../../../../web/'
kbwalk2uri4dragon [36] = '../../../../../web/'
kbwalk2uri4dragon [37] = '../../../../web/'
kbwalk2uri4dragon [38] = '../../../web/'
kbwalk2uri4dragon [39] = '../../web/'
kbwalk2uri4dragon [40] = '../web/'
kbwalk2uri4dragon [41] = '../../../../../../../../studio4xi/'
kbwalk2uri4dragon [42] = '../../../../../../../studio4xi/'
kbwalk2uri4dragon [43] = '../../../../../../studio4xi/'
kbwalk2uri4dragon [44] = '../../../../../studio4xi/'
kbwalk2uri4dragon [45] = '../../../../studio4xi/'
kbwalk2uri4dragon [46] = '../../../studio4xi/'
kbwalk2uri4dragon [47] = '../../studio4xi/'
kbwalk2uri4dragon [48] = '../studio4xi/'
kbwalk2uri4dragon [49] = '../../../../../../../../sw4xi/'
kbwalk2uri4dragon [50] = '../../../../../../../sw4xi/'
kbwalk2uri4dragon [51] = '../../../../../../sw4xi/'
kbwalk2uri4dragon [52] = '../../../../../sw4xi/'
kbwalk2uri4dragon [53] = '../../../../sw4xi/'
kbwalk2uri4dragon [54] = '../../../sw4xi/'
kbwalk2uri4dragon [55] = '../../sw4xi/'
kbwalk2uri4dragon [56] = '../sw4xi/'
kbwalk2uri4dragon [57] = '../../../../../../../../stock4xi/'
kbwalk2uri4dragon [58] = '../../../../../../../stock4xi/'
kbwalk2uri4dragon [59] = '../../../../../../stock4xi/'
kbwalk2uri4dragon [60] = '../../../../../stock4xi/'
kbwalk2uri4dragon [61] = '../../../../stock4xi/'
kbwalk2uri4dragon [62] = '../../../stock4xi/'
kbwalk2uri4dragon [63] = '../../stock4xi/'
kbwalk2uri4dragon [64] = '../stock4xi/'
kbwalk2uri4dragon [65] = '../../../../../../../../master/'
kbwalk2uri4dragon [66] = '../../../../../../../master/'
kbwalk2uri4dragon [67] = '../../../../../../master/'
kbwalk2uri4dragon [68] = '../../../../../master/'
kbwalk2uri4dragon [69] = '../../../../master/'
kbwalk2uri4dragon [70] = '../../../master/'
kbwalk2uri4dragon [71] = '../../master/'
kbwalk2uri4dragon [72] = '../master/'
kbwalk2uri4dragon [73] = '../../../../../../../../scope4xi/'
kbwalk2uri4dragon [74] = '../../../../../../../scope4xi/'
kbwalk2uri4dragon [75] = '../../../../../../scope4xi/'
kbwalk2uri4dragon [76] = '../../../../../scope4xi/'
kbwalk2uri4dragon [77] = '../../../../scope4xi/'
kbwalk2uri4dragon [78] = '../../../scope4xi/'
kbwalk2uri4dragon [79] = '../../scope4xi/'
kbwalk2uri4dragon [80] = '../scope4xi/'
kbwalk2uri4dragon [81] = '../../../../../../../../icewaves/'
kbwalk2uri4dragon [82] = '../../../../../../../icewaves/'
kbwalk2uri4dragon [83] = '../../../../../../icewaves/'
kbwalk2uri4dragon [84] = '../../../../../icewaves/'
kbwalk2uri4dragon [85] = '../../../../icewaves/'
kbwalk2uri4dragon [86] = '../../../icewaves/'
kbwalk2uri4dragon [87] = '../../icewaves/'
kbwalk2uri4dragon [88] = '../icewaves/'
kbwalk2uri4dragon [89] = '../../../../../../../../pc4xi/'
kbwalk2uri4dragon [90] = '../../../../../../../pc4xi/'
kbwalk2uri4dragon [91] = '../../../../../../pc4xi/'
kbwalk2uri4dragon [92] = '../../../../../pc4xi/'
kbwalk2uri4dragon [93] = '../../../../pc4xi/'
kbwalk2uri4dragon [94] = '../../../pc4xi/'
kbwalk2uri4dragon [95] = '../../pc4xi/'
kbwalk2uri4dragon [96] = '../pc4xi/'
kbwalk2uri4dragon [97] = '../../../../../../../../xi/'
kbwalk2uri4dragon [98] = '../../../../../../../xi/'
kbwalk2uri4dragon [99] = '../../../../../../xi/'
kbwalk2uri4dragon [100] = '../../../../../xi/'
kbwalk2uri4dragon [101] = '../../../../xi/'
kbwalk2uri4dragon [102] = '../../../xi/'
kbwalk2uri4dragon [103] = '../../xi/'
kbwalk2uri4dragon [104] = '../xi/'
keys2walk2uri4dragon = kbwalk2uri4dragon.keys()


# ===============================
# PROFILES - PROGRAM
# ===============================
profile2fetch4dragon = {}
profile2fetch4dragon [1] = '.HTML'                            
profile2fetch4dragon [2] = '.html'
profile2fetch4dragon [3] = '.HTM'
profile2fetch4dragon [4] = '.htm'
keys2profile4dragon = profile2fetch4dragon.keys()

total2ackuri4dragon  = 0
total2nackuri4dragon = 0
total2ackurl4dragon  = 0
total2nackurl4dragon = 0

# ===============================
# TO BE OMITTED - PROGRAM
# ===============================
kb2omit4dragon = {}
kb2omit4dragon [1] = "index.html"                    # these are populated in portal folders to prevent unauthorized access
kb2omit4dragon [2] = "uri2dragon4yo.html"            # the output file to be generated


# ===============================
# TO BE OMITTED - USER
# - ONLY for below domains!
# ===============================

# --------------------------------------------------
# icewaves - do NOT leave these on to other domains!
# --------------------------------------------------
# kb2omit4dragon [3] = "index_show"
# kb2omit4dragon [4] = "2h2fd2"
# kb2omit4dragon [5] = "h2rd"
# kb2omit4dragon [6] = "prd4b"
# kb2omit4dragon [7] = "prd4p"
# kb2omit4dragon [8] = "prd4w"
# kb2omit4dragon [9] = "leyout"
# kb2omit4dragon [10] = "h2fd4b"
# kb2omit4dragon [11] = "h2fd4p"
# kb2omit4dragon [12] = "h2fd4w"
# kb2omit4dragon [13] = "index_show_bus.html"
# kb2omit4dragon [14] = "index_show_mil.html"
# kb2omit4dragon [15] = "index_show_pat.html"
# --------------------------------------------
# sw4xi
# --------------------------------------------
kb2omit4dragon [3] = "sgml_input.html"               
keys2omit4dragon = kb2omit4dragon.keys()
# --------------------------------------------
# NOTE: do NOT set above on for other domains!
# --------------------------------------------

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "verify2ref4dragon" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def verify2ref4dragon(target2explore4dragon):
    global ack2debug4dragon
    global ack2relative4dragon
    global ack2skip4dragon
    global ack2href4dragon
    global ack2html4dragon
    global ack2http4dragon
    
    global ack2urltest4dragon
    global ack2uricheck4dragon
    
    global ack2urlwarn4dragon
    
    global count2ackuri4dragon 
    global count2nackuri4dragon
    global count2ackurl4dragon 
    global count2nackurl4dragon 
    global count2found4dragon
    global count2passed4dragon
    global count2relative4dragon
        
    global dragon2ref4uri

    global end2weblink4dragon
    
    global fileobject2stat4dragon
    global fileobject2target4dragon
    global fileobject2verify4dragon 

        
    global kb2find4dragon
    global keys2profile4dragon
    global key2profile4dragon
    global keys2hyper4dragon
    global keys2ext4dragon
    
    global kb2badhyper4dragon
    global keys2badhyper4dragon
    
    global kbdomain2uri4dragon
    global keys2domain2uri4dragon
    
    global kbfocus2uri4dragon
    global keys2focus2uri4dragon

    global kbwalk2uri4dragon
    global keys2walk2uri4dragon
 

       
    global pattern2relative4dragon
    global pattern2onerelative4dragon
    global pattern2tworelative4dragon
    global pattern2threerelative4dragon
    global pattern2fourrelative4dragon
    global pattern2fiverelative4dragon
    global pattern2sixrelative4dragon
    global pattern2sevenrelative4dragon
    global pattern2eightrelative4dragon
    
    global pattern2skip4dragon
    global pattern2skipone4dragon
    global pattern2skiptwo4dragon
    global pattern2skipthree4dragon
    global pattern2skipfour4dragon
    global pattern2skipfive4dragon
    global pattern2skipsix4dragon
    global pattern2skipseven4dragon
    global pattern2skipeight4dragon
      
    global pattern2href4dragon
    global pattern2inside4dragon
    global pattern2ext4dragon
    global pattern2hyper4dragon
    
    global profile2fetch4dragon
    
    global total2ackuri4dragon
    global total2nackuri4dragon
    global total2ackurl4dragon
    global total2nackurl4dragon    
  
    global kb2omit4dragon
    global keys2omit4dragon 
    
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4dragon    = count2found4dragon + 1
    count2ackuri4dragon   = 0
    count2nackuri4dragon  = 0
    count2ackurl4dragon   = 0 
    count2nackurl4dragon  = 0
    count2relative4dragon        = 0
                          
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4dragon)
    
    ack2profile = False
    for key2profile4dragon in keys2profile4dragon:
        if name2target[1] == profile2fetch4dragon[key2profile4dragon]:                                                             
            ack2profile = True

    # ---------------------------------------------------------------------------------------------
    # TEST PROFILE
    # ---------------------------------------------------------------------------------------------                
    for key2omit4dragon in keys2omit4dragon:
        index2skip4dragon=str.find(target2explore4dragon,kb2omit4dragon[key2omit4dragon]) 
        if index2skip4dragon == -1:
            pass
        else:
            ack2profile = False      
                           
    # ---------------------------------------------------------------------------------------------
    # DECIDE
    # ---------------------------------------------------------------------------------------------     
    if ack2profile is True:          
        # -----------------------------------------------------------------------------------------
        # UNIFY PATH2URI4DRAGON
        # -----------------------------------------------------------------------------------------
        count2winlevel4dragon = 0
        ack2modified = False
        target2modify4dragon = target2explore4dragon
        while 1:
            index2winlevel4dragon=str.find(target2modify4dragon,winpattern2level4dragon)    
            if index2winlevel4dragon == -1:
                break
            else:
                try:
                    target2modify4dragon = target2modify4dragon[0:index2winlevel4dragon] + webpattern2level4dragon + target2modify4dragon[index2winlevel4dragon+len2winpattern4dragon:]
                    ack2modified = True
                    count2winlevel4dragon = count2winlevel4dragon + 1
                    if count2winlevel4dragon > 33:
                        break
                except:             
                    print ('(STEP 1Z/33) OF VERIFY2REF4DRAGON *** FAILED TO SET MODIFIED TARGET2EXPLORE4DRAGON *** ')
                    # 
                    break                    
                                 
        
        if ack2modified is False:
            if ack2debug4dragon is True:
                print ('(STEP 1A/33) OF VERIFY2REF4DRAGON - CONTINUING FILE WITH ORIGINAL PATH: ' + target2explore4dragon)
                # 
        else:
            if ack2debug4dragon is True:
                print ('(STEP 1B/33) OF VERIFY2REF4DRAGON - DISCOVERED FILE WITH COMPLEX PATH: ' + target2explore4dragon)  
                # 
            target2explore4dragon = target2modify4dragon # swap
            if ack2debug4dragon is True:
                print ('(STEP 1C/33) OF VERIFY2REF4DRAGON - CONTINUING WITH MODIFIED PATH: ' + target2explore4dragon)
                # 
                     
        try:
            # ================================================================     
            line2write4dragon = '<br />' +  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~' + ' \n'
            fileobject2stat4dragon.write(line2write4dragon)
            line2write4dragon = '<br /><b>' + 'Verifying URIs</b>' + ' in <b>&raquo;</b><a href="' + str(target2explore4dragon)  + '" target="_blank">' + str(target2explore4dragon) + '</a>' + ' \n'
            fileobject2stat4dragon.write(line2write4dragon)
            # ================================================================     
        except:
            print ('(STEP 1Z/33) OF VERIFY2REF4DRAGON *** FAILED TO WRITE WITH FILEOBJECT2STAT4DRAGON *** ')
            #          
        fileobject2target4dragon = open(target2explore4dragon,'r')
        while 1:
            # -------------------------------------------------------------------------------------
            # FILE TO BE VERIFIED
            # -------------------------------------------------------------------------------------
            line2check4dragon = fileobject2target4dragon.readline()    # process an input line
            if not line2check4dragon:
                break                                                  # all lines have been read
            else:
                for key2find4dragon in keys2find4dragon:
                    # -----------------------------------------------------------------------------
                    # LINES TO BE VERIFIED
                    # -----------------------------------------------------------------------------
                    if kb2find4dragon[key2find4dragon] == rare2find4dragon:         
                        break                                          # nothing to be find anymore
                    else:
                        # ------------------------------------------------------------------------- 
                        # LINE TO BE VERIFIED
                        # ------------------------------------------------------------------------- 
                        ack2relative4dragon    = False
                        ack2href4dragon        = False
                        ack2html4dragon        = False
                        ack2http4dragon        = False
                        ack2low4dragon         = False
                        ack2normaluriup4dragon = False
                        ack2abnormal4dragon    = False
                        down2ultimate4dragon   = ''
                        count2relative4dragon         = 0
                        
                        # ------------------------------------------------------------------------- 
                        # RELATIVE HYPERLINK CHECK
                        # -------------------------------------------------------------------------    
                        index2start4dragon=str.find(line2check4dragon,kb2find4dragon[key2find4dragon])
                        if index2start4dragon == -1:
                            # ---------------------------------------------------------------------
                            # NOT RELATIVE HYPERLINK TO UPPER LEVEL
                            # ---------------------------------------------------------------------
                            index2href4dragon=str.find(line2check4dragon,pattern2href4dragon)
                            if index2href4dragon == -1:
                                # ----------------------------------------------------------------
                                # NOT ANY HYPERLINK !
                                # ---------------------------------------------------------------- 
                                count2passed4dragon = count2passed4dragon + 1
                            else:
                                # -------------------------------------------------------------
                                # YES, HYPERLINK, BUT WHICH KIND OF ?
                                # -------------------------------------------------------------
                                index2inside4dragon=str.find(line2check4dragon,pattern2inside4dragon)
                                if index2inside4dragon == -1:
                                   
                                   # ---------------------------------------------------------------------
                                   # EXAMINED WHETHER INTERNET PROCOL SUCH AS HTTP, FTP  
                                   # ---------------------------------------------------------------------
                                   match2hyper4dragon = pattern2hyper4dragon [1] 
                                   while 1:
                                       for key2hyper4dragon in keys2hyper4dragon:
                                           index2hyper4dragon=str.find(line2check4dragon,pattern2hyper4dragon [key2hyper4dragon])
                                           if index2hyper4dragon == -1:
                                               pass
                                           else:
                                               match2hyper4dragon = pattern2hyper4dragon [key2hyper4dragon]
                                               index2match4dragon = key2hyper4dragon
                                               break
                                       break
                                                       
                                   if index2hyper4dragon == -1:
                                       try:
                                           # ---------------------------------------------------------
                                           # URI - HYPERLINK TO LOWER LEVEL 
                                           # ---------------------------------------------------------
                                           ack2low4dragon = True
                                           ack2relative4dragon = True
                                           if ack2debug4dragon is True:
                                               print ('----------------------------------------------------------------------------------------------------------------------------------------------------------------')
                                               print ('(STEP 2A01/33) OF VERIFY2REF4DRAGON - FOUND HYPERLINK TO LOWER LEVEL IN: ', line2check4dragon)
                                               # 
                                               
                                       except:
                                           print ('(STEP 2Z1/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE LOWLEVEL URI FOR LINE: ', line2check4dragon)
                                           # 
                                       try:        
                                           # --------------------------------------------------------------------
                                           # URI - CHECK VARIOUS URI EXTENSIONS SUCH AS HTML, HTM, PDF / HTML, HTM, PDF
                                           # --------------------------------------------------------------------
                                           count2ext4dragon = 0
                                           match2ext4dragon = pattern2ext4dragon  [1] # default
                                           index2extmatch4dragon = 1
                                           for key2ext4dragon in keys2ext4dragon:
                                               index2lowlevelend4dragon=str.find(line2check4dragon,pattern2ext4dragon [key2ext4dragon])
                                               if index2lowlevelend4dragon == -1:
                                                   pass        
                                               else:
                                                   index2extmatch4dragon = index2lowlevelend4dragon
                                                   match2ext4dragon = pattern2ext4dragon [key2ext4dragon]
                                                                                                      
                                       except:
                                           print ('(STEP 2Z2/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE LOWLEVEL URI FOR LINE: ', line2check4dragon)
                                           # 
                                       try:
                                           # ==============================================================================================================================================
                                           # URI - FORMULA 
                                           # ==============================================================================================================================================       
                                           rest2lowleveluri4dragon = line2check4dragon[index2href4dragon+len(pattern2href4dragon):index2extmatch4dragon+len(match2ext4dragon)-1]
                                           if ack2debug4dragon is True:
                                               print ('(STEP 2A029/33) OF VERIFY2REF4DRAGON - REST2LOWLEVELURI4DRAGON: ', rest2lowleveluri4dragon)
                                               # 
                                       except:
                                           print ('(STEP 2Z3/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE LOWLEVEL URI FOR LINE: ', line2check4dragon)
                                           #
                                       try:         
                                           begin2lowlevel4dragon = ''
                                           pattern2lowlevel4dragon = '//'
                                           source2lowlevel4dragon = target2explore4dragon
                                           if ack2debug4dragon is True:
                                               print ('(STEP 2A03/33) OF VERIFY2REF4DRAGON - SOURCE2LOWLEVEL4DRAGON ', source2lowlevel4dragon)
                                               # 
                                               
                                           count2low4dragon = 0
                                           while 1:
                                               count2low4dragon = count2low4dragon + 1
                                               if count2low4dragon > 33:
                                                   break
                                               index2lowlevel4dragon=str.find(source2lowlevel4dragon,pattern2lowlevel4dragon)
                                               if index2lowlevel4dragon == -1:
                                                   break
                                               else:
                                                   begin2lowlevel4dragon = begin2lowlevel4dragon + source2lowlevel4dragon[0:index2lowlevel4dragon+len(pattern2lowlevel4dragon)] 
                                                   source2lowlevel4dragon = source2lowlevel4dragon[index2lowlevel4dragon+len(pattern2lowlevel4dragon):] 
                                                   
                                            
                                           # ========================================================================
                                           # URI - LOWER LEVEL REFERRED
                                           # ========================================================================           
                                           final2lowleveluri4dragon = begin2lowlevel4dragon + rest2lowleveluri4dragon                    
                                           if ack2debug4dragon is True:
                                               print ('(STEP 2A10/33) OF VERIFY2REF4DRAGON - FINAL2LOWLEVELURI4DRAGON ', final2lowleveluri4dragon)
                                               # 
                                           try:    
                                               uriobject2verify4dragon = open(final2lowleveluri4dragon,'r')
                                               if ack2debug4dragon is True:
                                                   print ('(STEP 2A11/33) OF VERIFY2REF4DRAGON - OPENED URIOBJECT2VERIFY4DRAGON : ', uriobject2verify4dragon)
                                                   #  
                                               uriobject2verify4dragon.close()
                                               if ack2debug4dragon is True:
                                                   print ('(STEP 2A12/33) OF VERIFY2REF4DRAGON - CLOSED URIOBJECT2VERIFY4DRAGON : ', uriobject2verify4dragon)
                                                   # 
                                               if ack2uricheck4dragon is True:        
                                                   try:
                                                       # ------------------------------------------------------------------------------------------------------------
                                                       # REPORT SUCCESFULLY OPENED AND CLOSED URI (NOT AS HYPERLINK)
                                                       # ------------------------------------------------------------------------------------------------------------      
                                                       line2write4dragon = '<br />' + '[URI]: ' + str(final2lowleveluri4dragon) + ' [ACK]' + ' \n'
                                                       fileobject2stat4dragon.write(line2write4dragon)
                                                       count2ackuri4dragon = count2ackuri4dragon + 1
                                                       total2ackuri4dragon = total2ackuri4dragon + 1
                                                   except:
                                                       print ('(STEP 20Z1/33) OF VERIFY2REF4DRAGON - *** FAILED TO WRITE WITH FILEOBJECT2STAT4DRAGON ***')        
                                           except:
                                               print ('(STEP 20Z2/33) OF VERIFY2REF4DRAGON *** FAILED TO OPEN FINAL2LOWLEVELURI4DRAGON : ', final2lowleveluri4dragon)
                                               # 
                                               try:
                                                   # ------------------------------------------------------------------------------------------------------------
                                                   # REPORT URI NOT OPENED AND CLOSED (NOT AS HYPERLINK)
                                                   # ------------------------------------------------------------------------------------------------------------      
                                                   line2write4dragon = '<br />' + '[URI]: ' + str(final2lowleveluri4dragon) + ' [NACK] LINE ' + line2check4dragon + ' \n'
                                                   fileobject2stat4dragon.write(line2write4dragon)
                                                   count2nackuri4dragon = count2nackuri4dragon + 1
                                                   total2nackuri4dragon = total2nackuri4dragon + 1
                                               except:
                                                   print ('(STEP 20Z3/33) OF VERIFY2REF4DRAGON - *** FAILED TO WRITE WITH FILEOBJECT2STAT4DRAGON ***')
                                           # ------------------------------------------------------------------------
                                           # URI - PROCESSED
                                           # ------------------------------------------------------------------------        
                                       except:
                                           print ('(STEP 2Z4/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE LOWLEVEL URI FOR LINE: ', line2check4dragon)
                                           # 
                                                           
                                   else:
                                       # ---------------------------------------------------------
                                       # URL -HYPERLINK TO WEB (INDEX2HYPER4DRAGON)
                                       # ---------------------------------------------------------
                                       ack2http4dragon = True
                                       for key2badhyper4dragon in keys2badhyper4dragon:
                                           index2badhyper4dragon=str.find(line2check4dragon,kb2badhyper4dragon [key2badhyper4dragon])    
                                           if index2badhyper4dragon == -1:
                                               pass
                                           else:
                                               ack2http4dragon = False        
                                       if ack2http4dragon is True:
                                           # ---------------------------------------------------------
                                           # WEB PROTOCOL TO BE CHECKED
                                           # ---------------------------------------------------------
                                           if ack2debug4dragon is True:
                                               print ('----------------------------------------------------------------------------------------------------------------------------------------------------------------')
                                               print ('(STEP 2A03/33) OF VERIFY2REF4DRAGON - FOUND WEB HYPERLINK IN: ', line2check4dragon)  
                                               # 
                                           try:
                                               resturl2check4dragon  = line2check4dragon[index2hyper4dragon+len(match2hyper4dragon):]
                                               if ack2debug4dragon is True:
                                                   print ('(STEP 2A04/33) OF VERIFY2REF4DRAGON - RESTURL2CHECK4DRAGON: ', resturl2check4dragon) 
                                                   # 
                                           except:
                                               print ('(STEP 2Z6/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE RESTURL2CHECK4DRAGON FOR LINE  ', line2check4dragon)
                                               # 
                                                           
                                           index2webend4dragon=str.find(resturl2check4dragon,'"')
                                           if index2webend4dragon == -1:
                                               if ack2debug4dragon is True:
                                                   print ('(STEP 2Z5/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE WEB URL FOR LINE, END2WEBLINK4DRAGON MISSING IN  ', line2check4dragon)
                                                   # 
                                               line2write4dragon = '<br />' + '[URL]: ' + str(line2check4dragon) + ' [NACK]' + ' \n'
                                               fileobject2stat4dragon.write(line2write4dragon)
                                               count2nackurl4dragon = count2nackurl4dragon + 1
                                               total2nackurl4dragon = total2nackurl4dragon + 1
                                           else:
                                               try: 
                                                   rest2weburl4dragon  = resturl2check4dragon[0:index2webend4dragon]
                                                   if ack2debug4dragon is True:
                                                       print ('(STEP 2A05/33) OF VERIFY2REF4DRAGON - REST2WEBURL4DRAGON: ', rest2weburl4dragon) 
                                                       # 
                                               except:
                                                   print ('(STEP 2Z7/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE rest2weburl4dragon FOR LINE  ', line2check4dragon)
                                                   # 
                                                   
                                               try:
                                                   # ================================================================================================================
                                                   # URL SCHEMA 
                                                   # ================================================================================================================   
                                                   urlsource2web4dragon = match2hyper4dragon + rest2weburl4dragon
                                                   if ack2debug4dragon is True:
                                                       print ('(STEP 2A06/33) OF VERIFY2REF4DRAGON - URLSOURCE2WEB4DRAGON: ', urlsource2web4dragon) 
                                                       # 
                                               except:
                                                   print ('(STEP 2Z9/33) OF VERIFY2REF4DRAGON *** FAILED TO SET urlsource2web4dragon FOR LINE  ', line2check4dragon)
                                                   # 
                                                   
                                                          
                                               url2open4dragon = None    
                                           
                                               if ack2urltest4dragon is True: 
                                                   try:
                                                       url2open4dragon = request.urlopen(urlsource2web4dragon)
                                                       if ack2debug4dragon is True:
                                                           print ('(STEP 2A08/33) OF VERIFY2REF4DRAGON - GOT URL2OPEN4DRAGON ', url2open4dragon, ' FOR LINE  ', line2check4dragon)
                                                           # 
                                                        
                                                       if ack2uricheck4dragon is True:
                                                           try:         
                                                               # ========================================================================
                                                               # WEB URL ACKNOWLEDGED
                                                               # ========================================================================
                                                               line2write4dragon = '<br />' + '[URL]: ' + '<b>&raquo;</b><a href="' + str(urlsource2web4dragon) + '" target="_blank">' + urlsource2web4dragon + '</a>' + ' [ACK] ' + ' \n'
                                                               fileobject2stat4dragon.write(line2write4dragon)
                                                               count2ackurl4dragon = count2ackurl4dragon + 1
                                                               total2ackurl4dragon = total2ackurl4dragon + 1
                                                           except:
                                                               print ('(STEP 2Z11/33) OF VERIFY2REF4DRAGON *** FAILED TO WRITE [WEB URL] FOR LINE ', line2check4dragon)
                                                               # 
                                                               
                                                   except:
                                                       print ('(STEP 2Z10/33) OF VERIFY2REF4DRAGON *** FAILED TO OPEN WEB URL URLSOURCE2WEB4DRAGON ', urlsource2web4dragon)
                                                       # 
                                                       # ========================================================================
                                                       # FAILED TO OPEN URL - ERROR, OFFILE, SERVER SLOW POSSIBILITIES
                                                       # ========================================================================
                                                       line2write4dragon = '<br />' + '[URL]: ' + '<b>&raquo;</b><a href="' + str(urlsource2web4dragon) + '" target="_blank">' + urlsource2web4dragon + '</a>' + ' [NACK] LINE ' + line2check4dragon + ' \n'
                                                       fileobject2stat4dragon.write(line2write4dragon)
                                                       count2nackurl4dragon = count2nackurl4dragon + 1
                                                       total2nackurl4dragon = total2nackurl4dragon + 1
                                                       
                                                      
                                               else:
                                                   # ------------------------------------------------------------------------
                                                   # WEB URL ACKNOWLEDGED - NOT ACCESSED (FTP, MAIL ...) 
                                                   # ------------------------------------------------------------------------
                                                   if ack2debug4dragon is True:
                                                       print ('(STEP A08/33) OF VERIFY2REF4DRAGON - SKIPPED URL CHECK DUE TO ITS TYPE IN ', line2check4dragon)
                                                       # 
                                                   
                                       else:
                                           # ------------------------------------------------------------------------
                                           # WEB PROTOCOL NOT TO BE CHECKED 
                                           # ------------------------------------------------------------------------
                                           if ack2debug4dragon is True:
                                               print ('(STEP A09/33) OF VERIFY2REF4DRAGON - SKIPPED URL CHECK DUE TO ITS TYPE IN ', line2check4dragon)
                                               # 
                                           try:
                                               ack2relative4dragon = False
                                           except:
                                               print ('(STEP A09Z/33) OF VERIFY2REF4DRAGON *** FAILED IN SKIPPING URL CHECK DUE TO ITS TYPE IN ', line2check4dragon)
                                               #         
                                       # ---------------------------------------------------------
                                       # EOF URL -HYPERLINK TO WEB PROCESSING
                                       # ---------------------------------------------------------
                                else:
                                    # -------------------------------------------------------
                                    # INSIDE HTML FILE (<a href="#000"><b>&Sigma ...) SKIPPED
                                    # -------------------------------------------------------
                                    pass
                                    
                        # ------------------------------------------------------------------------- 
                        # EOF RELATIVE HYPERLINK CHECK 
                        # -------------------------------------------------------------------------             
                        else:
                            # ---------------------------------------------------------------------
                            # RELATIVE - NOT TO LOWER LEVEL WHICH PROCESSED ABOVE 
                            # ---------------------------------------------------------------------
                            ack2relative4dragon = True
                                                                        
                        if ((ack2relative4dragon is True) and (ack2low4dragon is False)):         
                            # ----------------------------------------------------------------------
                            # RELATIVE URI FOUND - TO UPPER LEVEL (AT LEAST GOING FIRST UP)
                            # ---------------------------------------------------------------------- 
                            count2found4dragon = count2found4dragon + 1              # match 
                            if ack2debug4dragon is True:
                                print ('----------------------------------------------------------------------------------------------------------------------------------------------------------------')
                                print ('(STEP 2A/33) OF VERIFY2REF4DRAGON - FOUND RELATIVE URI IN : ', line2check4dragon)  
                                # eriarts: <br /><b>&raquo;</b><a href="../../sense/arts/us/en-us-arts-xi2.html" target="_blank">The United States Arts Sensing</a>
                                # norarts: <td><b>&laquo;</b><a href="../../index-arts-xi2.html" target="_blank">Arts</a></td>
                            # 
                            # ----------------------------------------------------------------------
                            # NORMAL URI UP - CHECK HOW MUCH UP
                            # ----------------------------------------------------------------------
                            index2eightup4dragon=str.find(line2check4dragon,pattern2eightrelative4dragon)
                            if ((index2eightup4dragon < -1) or (index2eightup4dragon > -1)):
                                index2eightskip4dragon=str.find(line2check4dragon,pattern2skipeight4dragon)
                                if index2eightskip4dragon == -1:
                                    try:
                                        rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2eightrelative4dragon):]
                                        if ack2debug4dragon is True:
                                            print ('(STEP 2Aeight/33) OF VERIFY2REF4DRAGON - NORMAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                            #
                                        ack2normaluriup4dragon = True
                                        count2relative4dragon = 8
                                        pattern2skip4dragon = pattern2eightrelative4dragon
                                        pattern2relative4dragon = pattern2eightrelative4dragon      
                                    except:
                                        print ('(STEP 2Z1eight/33) OF VERIFY2REF4DRAGON *** FAILED TO SET NORMAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                        # 
                            else:
                                index2sevenup4dragon=str.find(line2check4dragon,pattern2sevenrelative4dragon)
                                if ((index2sevenup4dragon < -1) or (index2sevenup4dragon > -1)):
                                    index2sevenskip4dragon=str.find(line2check4dragon,pattern2skipseven4dragon)
                                    if index2sevenskip4dragon == -1:
                                        try:
                                            rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2sevenrelative4dragon):]
                                            if ack2debug4dragon is True:
                                                print ('(STEP 2Aseven/33) OF VERIFY2REF4DRAGON - NORMAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                # 
                                            ack2normaluriup4dragon = True
                                            count2relative4dragon = 7
                                            pattern2skip4dragon = pattern2sevenrelative4dragon
                                            pattern2relative4dragon = pattern2sevenrelative4dragon       
                                        except:
                                            print ('(STEP 2Z1seven/33) OF VERIFY2REF4DRAGON *** FAILED TO SET NORMAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                            # 
                                else:
                                    index2sixup4dragon=str.find(line2check4dragon,pattern2sixrelative4dragon)
                                    if ((index2sixup4dragon < -1) or (index2sixup4dragon > -1)):
                                        index2sixskip4dragon=str.find(line2check4dragon,pattern2skipsix4dragon)
                                        if index2sixskip4dragon == -1:
                                            try:
                                                rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2sixrelative4dragon):]
                                                if ack2debug4dragon is True:
                                                    print ('(STEP 2Asix/33) OF VERIFY2REF4DRAGON - NORMAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                    #
                                                ack2normaluriup4dragon = True
                                                count2relative4dragon = 6
                                                pattern2skip4dragon = pattern2sixrelative4dragon
                                                pattern2relative4dragon = pattern2sixrelative4dragon         
                                            except:
                                                print ('(STEP 2Z1six/33) OF VERIFY2REF4DRAGON *** FAILED TO SET NORMAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                # 
                                    else:
                                        index2fiveup4dragon=str.find(line2check4dragon,pattern2fiverelative4dragon)
                                        if ((index2fiveup4dragon < -1) or (index2fiveup4dragon > -1)):
                                            index2fiveskip4dragon=str.find(line2check4dragon,pattern2skipfive4dragon)
                                            if index2fiveskip4dragon == -1:
                                                try:
                                                    rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2fiverelative4dragon):]
                                                    if ack2debug4dragon is True:
                                                        print ('(STEP 2Afive/33) OF VERIFY2REF4DRAGON - NORMAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                        #
                                                    ack2normaluriup4dragon = True
                                                    count2relative4dragon = 5
                                                    pattern2skip4dragon = pattern2fiverelative4dragon
                                                    pattern2relative4dragon = pattern2fiverelative4dragon        
                                                except:
                                                    print ('(STEP 2Z1five/33) OF VERIFY2REF4DRAGON *** FAILED TO SET NORMAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                    # 
                                        else:
                                            index2fourup4dragon=str.find(line2check4dragon,pattern2fourrelative4dragon)
                                            if ((index2fourup4dragon < -1) or (index2fourup4dragon > -1)):
                                                index2fourskip4dragon=str.find(line2check4dragon,pattern2skipfour4dragon)
                                                if index2fourskip4dragon == -1:
                                                    try:
                                                        rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2fourrelative4dragon):]
                                                        if ack2debug4dragon is True:
                                                            print ('(STEP 2Afour/33) OF VERIFY2REF4DRAGON - NORMAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                            # 
                                                        ack2normaluriup4dragon = True
                                                        count2relative4dragon = 4
                                                        pattern2skip4dragon = pattern2fourrelative4dragon
                                                        pattern2relative4dragon = pattern2fourrelative4dragon       
                                                    except:
                                                        print ('(STEP 2Z1four/33) OF VERIFY2REF4DRAGON *** FAILED TO SET NORMAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                        # 
                                            else:
                                                index2threeup4dragon=str.find(line2check4dragon,pattern2threerelative4dragon)
                                                if ((index2threeup4dragon < -1) or (index2threeup4dragon > -1)):
                                                    index2threeskip4dragon=str.find(line2check4dragon,pattern2skipthree4dragon)
                                                    if index2threeskip4dragon == -1:
                                                        try:
                                                            rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2threerelative4dragon):]
                                                            if ack2debug4dragon is True:
                                                                print ('(STEP 2Athree/33) OF VERIFY2REF4DRAGON - NORMAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                                #
                                                            ack2normaluriup4dragon = True
                                                            count2relative4dragon = 3
                                                            pattern2skip4dragon = pattern2threerelative4dragon
                                                            pattern2relative4dragon = pattern2threerelative4dragon        
                                                        except:
                                                            print ('(STEP 2Z1three/33) OF VERIFY2REF4DRAGON *** FAILED TO SET NORMAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                            # 
                                                else:
                                                    index2twoup4dragon=str.find(line2check4dragon,pattern2tworelative4dragon)
                                                    if ((index2twoup4dragon < -1) or (index2twoup4dragon > -1)):
                                                        index2twoskip4dragon=str.find(line2check4dragon,pattern2skiptwo4dragon)
                                                        if index2twoskip4dragon == -1:
                                                            try:
                                                                rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2tworelative4dragon):]
                                                                if ack2debug4dragon is True:
                                                                    print ('(STEP 2Atwo/33) OF VERIFY2REF4DRAGON - NORMAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                                    # norarts: index-arts-xi2.html" target="_blank">Arts</a></td>
                                                                    # 
                                                                ack2normaluriup4dragon = True
                                                                count2relative4dragon = 2
                                                                pattern2skip4dragon = pattern2tworelative4dragon
                                                                pattern2relative4dragon = pattern2tworelative4dragon      
                                                            except:
                                                                print ('(STEP 2Z1two/33) OF VERIFY2REF4DRAGON *** FAILED TO SET NORMAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                                # 
                                                    else:
                                                        index2oneskip4dragon=str.find(line2check4dragon,pattern2skipone4dragon)
                                                        if index2oneskip4dragon == -1:
                                                            try:
                                                                rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2onerelative4dragon):]
                                                                if ack2debug4dragon is True:
                                                                    print ('(STEP 2Aone/33) OF VERIFY2REF4DRAGON - NORMAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                                    # index-arts-xi2.html" target="_blank">Arts</a></td>
                                                                count2relative4dragon = 1   
                                                                ack2normaluriup4dragon = True
                                                                pattern2skip4dragon = pattern2onerelative4dragon
                                                                pattern2relative4dragon = pattern2onerelative4dragon      
                                                            except:
                                                                print ('(STEP 2Zone/33) OF VERIFY2REF4DRAGON *** FAILED TO SET NORMAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                                # 
                            # ----------------------------------------------------------------------
                            # END OF CHECKING HOW MUCH UP NORMAL URI REFERS
                            # ----------------------------------------------------------------------      
    
                            # ----------------------------------------------------------------------
                            # ABNORMAL COMPLICATED URI UP AND DOWN - NEWER VERSION 
                            # ----------------------------------------------------------------------
                            if ack2normaluriup4dragon is False:
                                ack2abnormal4dragon = True
                                down2ultimate4dragon = None
                                
                                key2walk2uri4dragon = 0
                                while 1:
                                    key2walk2uri4dragon = key2walk2uri4dragon + 1
                                    if key2walk2uri4dragon > len(kbwalk2uri4dragon):
                                        break
                                
                                    index2eightskip4dragon=str.find(line2check4dragon,kbwalk2uri4dragon[key2walk2uri4dragon])
                                    if ((index2walk4dragon < -1) or (index2walk4dragon > -1)):
                                        if ((key2walk2uri4dragon  == 8)  or (key2walk2uri4dragon == 17) or (key2walk2uri4dragon == 25) or (key2walk2uri4dragon == 33)
                                          or (key2walk2uri4dragon == 41) or (key2walk2uri4dragon == 49) or (key2walk2uri4dragon == 58) or (key2walk2uri4dragon == 65)
                                          or (key2walk2uri4dragon == 73) or (key2walk2uri4dragon == 81) or (key2walk2uri4dragon == 89) or (key2walk2uri4dragon == 88)):
                                            # -----------------------------------------------------------------------------------------------------------------------
                                            # EIGHT (8)
                                            # -----------------------------------------------------------------------------------------------------------------------
                                            try:
                                                count2relative4dragon = 8 - 1 
                                                rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2eight4dragon)+2+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                down2ultimate4dragon = line2check4dragon[index2eightkip4dragon+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                if ack2debug4dragon is True:
                                                    print ('(STEP 2Beight/33) OF VERIFY2REF4DRAGON - SPECIAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                    # 
                                                    print ('(STEP 2Btwo8/33) OF VERIFY2REF4DRAGON - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)
                                                    # 
                                            except:
                                                print ('(STEP 2Z1eight/33) OF VERIFY2REF4DRAGON *** FAILED TO SET SPECIAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                # 
                                        else:
                                            pass        
                                    else:
                                        index2sevenskip4dragon=str.find(line2check4dragon,kbwalk2uri4dragon[key2walk2uri4dragon])
                                        if ((index2sevenskip4dragon < -1) or (index2sevenskip4dragon > -1)):
                                            if ((key2walk2uri4dragon  == 7)  or (key2walk2uri4dragon == 15) or (key2walk2uri4dragon == 23) or (key2walk2uri4dragon == 31)
                                                  or (key2walk2uri4dragon == 39) or (key2walk2uri4dragon == 45) or (key2walk2uri4dragon == 53) or (key2walk2uri4dragon == 61)
                                                  or (key2walk2uri4dragon == 69) or (key2walk2uri4dragon == 77) or (key2walk2uri4dragon == 85) or (key2walk2uri4dragon == 93)):
                                                    # -----------------------------------------------------------------------------------------------------------------------
                                                    # SEVEN (7)
                                                    # -----------------------------------------------------------------------------------------------------------------------
                                                try:
                                                    count2relative4dragon = 7 - 1
                                                    rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2sevenrelative4dragon)+2+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                    down2ultimate4dragon = line2check4dragon[index2sevenkip4dragon+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                    if ack2debug4dragon is True:
                                                        print ('(STEP 2Bseven/33) OF VERIFY2REF4DRAGON - SPECIAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                        #
                                                        print ('(STEP 2Btwo7/33) OF VERIFY2REF4DRAGON - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)
                                                        #  
                                                except:
                                                    print ('(STEP 2Z1seven/33) OF VERIFY2REF4DRAGON *** FAILED TO SET SPECIAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                    #
                                            else:
                                                pass         
                                        else:
                                            index2sixskip4dragon=str.find(line2check4dragon,kbwalk2uri4dragon[key2walk2uri4dragon])
                                            if ((index2sixskip4dragon < -1) or (index2sixskip4dragon > -1)):
                                                if ((key2walk2uri4dragon  == 6)  or (key2walk2uri4dragon == 14) or (key2walk2uri4dragon == 22) or (key2walk2uri4dragon == 30)
                                                    or (key2walk2uri4dragon == 38) or (key2walk2uri4dragon == 46) or (key2walk2uri4dragon == 54) or (key2walk2uri4dragon == 62)
                                                    or (key2walk2uri4dragon == 70) or (key2walk2uri4dragon == 78) or (key2walk2uri4dragon == 86) or (key2walk2uri4dragon == 94)):
                                                    # -----------------------------------------------------------------------------------------------------------------------
                                                    # SIX (6)
                                                    # -----------------------------------------------------------------------------------------------------------------------
                                                    try:
                                                        count2relative4dragon = 6 - 1
                                                        rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2sixrelative4dragon)+2+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                        down2ultimate4dragon = line2check4dragon[index2sixkip4dragon+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                        if ack2debug4dragon is True:
                                                            print ('(STEP 2Bsix/33) OF VERIFY2REF4DRAGON - SPECIAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                            # 
                                                            print ('(STEP 2Btwo6/33) OF VERIFY2REF4DRAGON - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)
                                                            # 
                                                    except:
                                                        print ('(STEP 2Z1six/33) OF VERIFY2REF4DRAGON *** FAILED TO SET SPECIAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                        #
                                                else:
                                                    pass         
                                            else:
                                                index2fiveskip4dragon=str.find(line2check4dragon,kbwalk2uri4dragon[key2walk2uri4dragon])
                                                if ((index2fiveskip4dragon < -1) or (index2fiveskip4dragon > -1)):
                                                    if ((key2walk2uri4dragon  == 5)  or (key2walk2uri4dragon == 13) or (key2walk2uri4dragon == 21) or (key2walk2uri4dragon == 29)
                                                      or (key2walk2uri4dragon == 37) or (key2walk2uri4dragon == 45) or (key2walk2uri4dragon == 53) or (key2walk2uri4dragon == 61)
                                                      or (key2walk2uri4dragon == 69) or (key2walk2uri4dragon == 77) or (key2walk2uri4dragon == 85) or (key2walk2uri4dragon == 93)):
                                                        # -----------------------------------------------------------------------------------------------------------------------
                                                        # FIVE (5)
                                                        # -----------------------------------------------------------------------------------------------------------------------
                                                        try:
                                                            count2relative4dragon = 5 - 1
                                                            rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2fiverelative4dragon)+2+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                            down2ultimate4dragon = line2check4dragon[index2fivekip4dragon+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                            if ack2debug4dragon is True:
                                                                print ('(STEP 2Bfive/33) OF VERIFY2REF4DRAGON - SPECIAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                                # 
                                                                print ('(STEP 2Btwo5/33) OF VERIFY2REF4DRAGON - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)
                                                                #   
                                                        except:
                                                            print ('(STEP 2Z1five/33) OF VERIFY2REF4DRAGON *** FAILED TO SET SPECIAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                            #
                                                    else:
                                                        pass             
                                                else:
                                                    index2fourskip4dragon=str.find(line2check4dragon,kbwalk2uri4dragon[key2walk2uri4dragon])
                                                    if ((index2fourskip4dragon < -1) or (index2fourskip4dragon > -1)):
                                                        if ((key2walk2uri4dragon  == 4)  or (key2walk2uri4dragon == 12) or (key2walk2uri4dragon == 20) or (key2walk2uri4dragon == 28)
                                                          or (key2walk2uri4dragon == 36) or (key2walk2uri4dragon == 44) or (key2walk2uri4dragon == 52) or (key2walk2uri4dragon == 60)
                                                          or (key2walk2uri4dragon == 68) or (key2walk2uri4dragon == 76) or (key2walk2uri4dragon == 84) or (key2walk2uri4dragon == 92)):
                                                            # -----------------------------------------------------------------------------------------------------------------------
                                                            # FOUR (4)
                                                            # -----------------------------------------------------------------------------------------------------------------------
                                                            try:
                                                                count2relative4dragon = 4 - 1
                                                                rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2fourrelative4dragon)+2+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                                down2ultimate4dragon = line2check4dragon[index2fourkip4dragon+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                                if ack2debug4dragon is True:
                                                                    print ('(STEP 2Bfour/33) OF VERIFY2REF4DRAGON - SPECIAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                                    # 
                                                                    print ('(STEP 2Btwo4/33) OF VERIFY2REF4DRAGON - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)
                                                                    # 
                                                            except:
                                                                print ('(STEP 2Z1four/33) OF VERIFY2REF4DRAGON *** FAILED TO SET SPECIAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                                # 
                                                        pass        
                                                    else:
                                                        index2threeskip4dragon=str.find(line2check4dragon,kbwalk2uri4dragon[key2walk2uri4dragon])
                                                        if ((index2threeskip4dragon < -1) or (index2threeskip4dragon > -1)):
                                                            if ((key2walk2uri4dragon   == 3)  or (key2walk2uri4dragon == 11) or (key2walk2uri4dragon == 19) or (key2walk2uri4dragon == 27)
                                                               or (key2walk2uri4dragon == 35) or (key2walk2uri4dragon == 43) or (key2walk2uri4dragon == 51) or (key2walk2uri4dragon == 59)
                                                               or (key2walk2uri4dragon == 67) or (key2walk2uri4dragon == 75) or (key2walk2uri4dragon == 83) or (key2walk2uri4dragon == 91)):
                                                                # -----------------------------------------------------------------------------------------------------------------------
                                                                # THREE (3)
                                                                # -----------------------------------------------------------------------------------------------------------------------
                                                                try:
                                                                    count2relative4dragon = 3 - 1                                                                                 
                                                                    rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2threerelative4dragon)+2+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                                    down2ultimate4dragon = line2check4dragon[index2threekip4dragon+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                                    if ack2debug4dragon is True:
                                                                        print ('(STEP 2Bthree/33) OF VERIFY2REF4DRAGON - SPECIAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                                        # 
                                                                        print ('(STEP 2Btwo3/33) OF VERIFY2REF4DRAGON - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)
                                                                        #  
                                                                except:
                                                                    print ('(STEP 2Z1three/33) OF VERIFY2REF4DRAGON *** FAILED TO SET NORMAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                                    #
                                                            else:
                                                                pass         
                                                        else:
                                                            index2twoskip4dragon=str.find(line2check4dragon,kbwalk2uri4dragon[key2walk2uri4dragon]) 
                                                            if ((index2twoskip4dragon < -1) or (index2twoskip4dragon > -1)):
                                                                if ((key2walk2uri4dragon  ==  7) or (key2walk2uri4dragon == 15) or (key2walk2uri4dragon == 23) or (key2walk2uri4dragon == 31)
                                                                  or (key2walk2uri4dragon == 39) or (key2walk2uri4dragon == 47) or (key2walk2uri4dragon == 55) or (key2walk2uri4dragon == 63)
                                                                  or (key2walk2uri4dragon == 71) or (key2walk2uri4dragon == 79) or (key2walk2uri4dragon == 87) or (key2walk2uri4dragon == 95)):
                                                                    # -----------------------------------------------------------------------------------------------------------------------
                                                                    # TWO (2)
                                                                    # -----------------------------------------------------------------------------------------------------------------------
                                                                    try:
                                                                        count2relative4dragon = 2 - 1
                                                                        rest2check4dragon    = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2tworelative4dragon)+2+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                                        down2ultimate4dragon = line2check4dragon[index2twoskip4dragon+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                                        if ack2debug4dragon is True:
                                                                            print ('(STEP 2Btwo1/33) OF VERIFY2REF4DRAGON - SPECIAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                                            # eriarts: en-us-arts-xi2.html" target="_blank">The United States Arts Sensing</a>
                                                                            # 
                                                                            print ('(STEP 2Btwo2/33) OF VERIFY2REF4DRAGON - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)
                                                                            # eriarts: arts/us/en-us-arts-xi2.html" target="_blank">The United States Arts Sensing</a>
                                                                            #
                                                                    except:
                                                                        print ('(STEP 2Z1two/33) OF VERIFY2REF4DRAGON *** FAILED TO SET SPECIAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                                        #
                                                                else:
                                                                    pass             
                                                            else:
                                                                # -----------------------------------------------------------------------------------------------------------------------
                                                                # ONE (1)
                                                                # -----------------------------------------------------------------------------------------------------------------------
                                                                if ((key2walk2uri4dragon    == 8) or (key2walk2uri4dragon == 16) or (key2walk2uri4dragon == 24) or (key2walk2uri4dragon == 32)
                                                                   or (key2walk2uri4dragon == 40) or (key2walk2uri4dragon == 48) or (key2walk2uri4dragon == 56) or (key2walk2uri4dragon == 64)
                                                                   or (key2walk2uri4dragon == 72) or (key2walk2uri4dragon == 80) or (key2walk2uri4dragon == 88) or (key2walk2uri4dragon == 96)):
                                                                    try:
                                                                        count2relative4dragon = 1 - 1
                                                                        rest2check4dragon = line2check4dragon[index2start4dragon+len(pattern2href4dragon)+len(pattern2onerelative4dragon)+2+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                                        down2ultimate4dragon = line2check4dragon[index2oneskip4dragon+len(kbwalk2uri4dragon[key2walk2uri4dragon]):]
                                                                        if ack2debug4dragon is True:
                                                                            print ('(STEP 2Bone/33) OF VERIFY2REF4DRAGON - SPECIAL REST2CHECK4DRAGON : ', rest2check4dragon)
                                                                            # 
                                                                            print ('(STEP 2Btwo1/33) OF VERIFY2REF4DRAGON - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)
                                                                            # 
                                                                    except:
                                                                        print ('(STEP 2Zone/33) OF VERIFY2REF4DRAGON *** FAILED TO SET SPECIAL REST2CHECK4DRAGON FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                                                        # 
                                    # ----------------------------------------------------------------------
                                    # EOF COMPLICATED URI UP AND DOWN - NEWER VERSION
                                    # ----------------------------------------------------------------------                               
                                    
                                    
                            # ----------------------------------------------------------------------
                            # RELATIVE - FIND END IN THE REST2CHECK4DRAGON 
                            # ----------------------------------------------------------------------
                            end2find4dragon = '"'
                            index2rest4dragon=str.find(rest2check4dragon, end2find4dragon)
                            if index2rest4dragon == -1:
                                 if ack2debug4dragon is True:
                                     print ('(STEP 4AZ1/33) OF VERIFY2REF4DRAGON *** ERROR IN URL - REST2CHECK4DRAGON : ', rest2check4dragon)  
                                     #
                                 try: 
                                     line2write4dragon = '<br /> *** failed to verify URI: ' + str(path2open4dragon) + ' line: ' + str(line2check4dragon) + '\n'
                                     fileobject2stat4dragon.write(line2write4dragon)
                                 except:
                                     print ('(STEP 4AZ2/33) OF VERIFY2REF4DRAGON *** FAILED TO WRITE WITH FILEOBJECT2STAT4DRAGON *** ')  
                                     # 
                            else:
                                 rest2check4dragon = rest2check4dragon[0:index2rest4dragon]
                                 if ack2debug4dragon is True:
                                     print ('(STEP 4A/33) OF VERIFY2REF4DRAGON - REST2CHECK4DRAGON : ', rest2check4dragon)     
                                     # eriarts: en-us-arts-xi2.html
                                     # norarts: index-arts-xi2.html
                                     
                            # ----------------------------------------------------------------------
                            # RELATIVE - SOLVE FINAL DOWN2ULTIMATE4DRAGON 
                            # ----------------------------------------------------------------------                                     
                            #          
                            if ack2abnormal4dragon is True:
                                try:
                                    end2find4dragon = '"'
                                    index2down4dragon=str.find(down2ultimate4dragon, end2find4dragon)
                                    if index2down4dragon == -1:
                                         if ack2debug4dragon is True:
                                             print ('(STEP 4BZ1/33) OF VERIFY2REF4DRAGON *** ERROR IN URI - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)  
                                             #
                                    else:
                                         down2ultimate4dragon = down2ultimate4dragon[0:index2down4dragon]
                                         # arts/us/en-us-arts-xi2.html  
                                         index2ultimatedown4dragon=str.find(down2ultimate4dragon, rest2check4dragon)
                                         if index2ultimatedown4dragon == -1:
                                             print ('(STEP 4BZ2/33) OF VERIFY2REF4DRAGON *** ERROR IN URI - DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)  
                                             # 
                                         else: 
                                             down2ultimate4dragon = down2ultimate4dragon[0:index2ultimatedown4dragon]   
                                             if ack2debug4dragon is True:
                                                 print ('(STEP 4B/33) OF VERIFY2REF4DRAGON - FINAL DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)     
                                                 # eriarts: arts/us/  
                                except:
                                    print ('(STEP 4BZ/33) OF VERIFY2REF4DRAGON *** FAILED TO SET FINAL DOWN2ULTIMATE4DRAGON : ', down2ultimate4dragon)     
                                    #
                                                                                        
                            # ----------------------------------------------------------------------
                            # RELATIVE  
                            # ----------------------------------------------------------------------
                            if ack2debug4dragon is True:
                                print ('(STEP 5A0/33) OF VERIFY2REF4DRAGON - ACK2RELATIVE4DRAGON ', ack2relative4dragon, ' ACK2LOW4DRAGON: ', ack2low4dragon, ' ACK2ABNORMAL4DRAGON: ', ack2abnormal4dragon, ' LINE2CHECK4DRAGON ', line2check4dragon)
                                # oneup: ACK2RELATIVE4DRAGON  True  ACK2LOW4DRAGON:  False  ACK2ABNORMAL4DRAGON:  False
                                # 
                            
                            if ((ack2relative4dragon is True) and (ack2low4dragon is False) and (ack2abnormal4dragon is False)):
                                # ------------------------------------------------------------------
                                #
                                # ------------------------------------------------------------------    
                                if count2relative4dragon == 0:
                                    # --------------------------------------------------------------
                                    # RELATIVE - COUNT RELATIVE LEVELS     
                                    # --------------------------------------------------------------                  
                                    if ack2debug4dragon is True:
                                        print ('(STEP 5A1/33) OF VERIFY2REF4DRAGON - TRYING TO COUNT COUNT2RELATIVE4DRAGON FOR LINE: ', line2check4dragon)
                                        # oneup: <td><b>&laquo;</b><a href="../index.html" target="_blank"><b>&Theta;</b> HOME</a></td>
                                        # 
                                        
                                    try:      
                                        relative2examine4dragon = line2check4dragon
                                        pattern2work4dragon = '<a href="'
                                        index2abondon4dragon=str.find(relative2examine4dragon,pattern2work4dragon)
                                        if ack2debug4dragon is True:
                                            print ('(STEP 5B10/33) OF VERIFY2REF4DRAGON - index2abondon4dragon: ', index2abondon4dragon)
                                            # oneup:    10
                                            # norarts:  18
                                            # 
                                            print ('(STEP 5B11/33) OF VERIFY2REF4DRAGON - len(pattern2work4dragon) ', len(pattern2work4dragon))
                                            # oneup:    9
                                            # norarts:  9
                                        relative2examine4dragon = relative2examine4dragon[index2abondon4dragon+len(pattern2work4dragon):]
                                        if ack2debug4dragon is True:
                                            print ('(STEP 5B12/33) OF VERIFY2REF4DRAGON - relative2examine4dragon ', relative2examine4dragon)
                                            # oneup:    ../index.html" target="_blank"><b>&Theta;</b> HOME</a></td>
                                            # spelarts: ../../sense/arts/us/en-us-arts-xi2.html" target="_blank">The United States Arts Sensing</a> <-- OK
                                            # norarts:  ../../index-arts-xi2.html" target="_blank">Arts</a></td>
                                            print ('(STEP 5B12/33) OF VERIFY2REF4DRAGON - PATTERN2SKIP4DRAGON: ', pattern2skip4dragon) 
                                            # spelarts and norarts: ../../ 
                                            # oneup:                ../
                                        while 1:
                                            index2abondon4dragon=str.find(relative2examine4dragon,pattern2skip4dragon)
                                            if index2abondon4dragon == -1:
                                                pass
                                            else:
                                                try:
                                                    relative2examine4dragon = relative2examine4dragon[index2abondon4dragon+len(pattern2skip4dragon):]
                                                    if ack2debug4dragon is True:
                                                        print ('(STEP 5B2/33) OF VERIFY2REF4DRAGON - NORMAL RELATIVE2EXAMINE4DRAGON: ', relative2examine4dragon)
                                                        # norarts: index-arts-xi2.html" target="_blank">Arts</a></td>
                                                        # oneup:   index.html" target="_blank"><b>&Theta;</b> HOME</a></td>
                                                        
                                                    count2relative4dragon = count2relative4dragon + 1
                                                    if ack2debug4dragon is True:
                                                        print ('(STEP 5C/33) OF VERIFY2REF4DRAGON - NORMAL  COUNT2RELATIVE4DRAGON: ', count2relative4dragon)
                                                        # oneup:   1
                                                        # norarts: 1
                                                          
                                                except:
                                                    print ('(STEP 5Z4/33) OF VERIFY2REF4DRAGON *** FAILED COUNT2RELATIVE4DRAGON: ', count2relative4dragon)
                                                    # 
                                                    break
                                            try:
                                                if ack2debug4dragon is True:
                                                    print ('(STEP 5T1/33) OF VERIFY2REF4DRAGON - relative2examine4dragon : ', relative2examine4dragon)
                                                    # oneup:   index.html" target="_blank"><b>&Theta;</b> HOME</a></td>
                                                    # norarts: index-arts-xi2.html" target="_blank">Arts</a></td>
                                                
                                            except:
                                                print ('(STEP 5Z5/33) OF VERIFY2REF4DRAGON *** FAILED TO UPDATE RELATIVE2EXAMINE4DRAGON FOR LINE ', line2check4dragon)
                                                # 
                                            try:          
                                                if ack2debug4dragon is True:
                                                    print ('(STEP 5T2/33) OF VERIFY2REF4DRAGON - pattern2relative4dragon : ', pattern2relative4dragon)
                                                    # oneup: ../
                                                    #           
                                            except:
                                                print ('(STEP 5Z6/33) OF VERIFY2REF4DRAGON *** FAILED TO UPDATE RELATIVE2EXAMINE4DRAGON FOR LINE ', line2check4dragon)
                                                #     
                                            try:        
                                                index2relative4dragon=str.find(relative2examine4dragon,pattern2relative4dragon)
                                                if index2relative4dragon == -1:
                                                    break
                                                else:
                                                    count2relative4dragon = count2relative4dragon + 1
                                                    # 1
                                                    if count2relative4dragon > 33:
                                                       break     
                                                    else:
                                                       try:
                                                           relative2examine4dragon = relative2examine4dragon[index2relative4dragon+len(pattern2relative4dragon):]
                                                           if ack2debug4dragon is True:
                                                               print ('(STEP 5D/33) OF VERIFY2REF4DRAGON - NEW RELATIVE2EXAMINE4DRAGON : ', relative2examine4dragon)
                                                               # 
                                                       except:
                                                           print ('(STEP 5Z7/33) OF VERIFY2REF4DRAGON *** FAILED TO UPDATE RELATIVE2EXAMINE4DRAGON FOR LINE ', line2check4dragon)
                                                           #        
                                                           break 
                                                if ack2debug4dragon is True:
                                                    print ('(STEP 5E/33) OF VERIFY2REF4DRAGON - COUNT2RELATIVE4DRAGON : ', count2relative4dragon)
                                                    # 
                                            except:
                                                print ('(STEP 5Z8/33) OF VERIFY2REF4DRAGON *** FAILED TO UPDATE RELATIVE2EXAMINE4DRAGON FOR LINE ', line2check4dragon)
                                                # <td><b>&laquo;</b><a href="../../index-arts-xi2.html" target="_blank">Arts</a></td>       
                                                break         
                                                          
                                    except:
                                        print ('(STEP 5Z9/33) OF VERIFY2REF4DRAGON *** FAILED TO COUNT RELATIVE LEVELS FOR LINE: ', line2check4dragon)
                                        #      
                                else:
                                    pass
                                    
                            # --------------------------------------------------------------
                            # RELATIVE  
                            # --------------------------------------------------------------
                            if ack2debug4dragon is True:
                                print ('(STEP 5F/33) OF VERIFY2REF4DRAGON - CONTINUED WITH COUNT2RELATIVE ', count2relative4dragon, ' ALREADY COUNTED FOR LINE2CHECK4DRAGON: ', line2check4dragon)
                                # oneup: CONTINUED WITH COUNT2RELATIVE  1  ALREADY COUNTED FOR LINE2CHECK4DRAGON:  <td><b>&laquo;</b><a href="../index-arts-xi2.html" target="_blank">Arts</a></td>
                                # twoup: CONTINUED WITH COUNT2RELATIVE  2  ALREADY COUNTED FOR LINE2CHECK4DRAGON:  <td><b>&laquo;</b><a href="../../index-arts-xi2.html" target="_blank">Arts</a></td>
                                # 
                                       
                            # ----------------------------------------------------------------------
                            # RELATIVE - CREATE FILE PATH OF HYPERLINK 
                            # ----------------------------------------------------------------------           
                            if ack2debug4dragon is True:
                                print ('(STEP 6A/33) OF VERIFY2REF4DRAGON - TRYING TO CREATE HYPERLINK REFERRED BY LINE2CHECK4DRAGON: ', line2check4dragon)
                                # oneup:   <td><b>&laquo;</b><a href="../index.html" target="_blank"><b>&Theta;</b> HOME</a></td>
                                # norarts: <td><b>&laquo;</b><a href="../../index-arts-xi2.html" target="_blank">Arts</a></td>
                                # eriarts: <br /><b>&raquo;</b><a href="../../sense/arts/us/en-us-arts-xi2.html" target="_blank">The United States Arts Sensing</a>
                                
                                #  
                                print ('(STEP 6B/33) OF VERIFY2REF4DRAGON - TARGET2EXPLORE4DRAGON: ', target2explore4dragon) 
                                # oneup:   F://temp//yosense//test2dragon//sense//index-sense-xi2.html
                                # norarts: F://temp//yosense//test2dragon//sense//arts//ro//en//en-ro-arts-xi2.html
                                # eriarts: F://temp//yosense//test2dragon//sense//arts//index-arts-xi2.html
                                                                # 
                            search2level4dragon = target2explore4dragon 
                            try:
                                if count2relative4dragon > 0:
                                    # ----------------------------------------------------------------------
                                    # MAKE SURE URI IS THE SAME STANDAR FORMAT
                                    # ----------------------------------------------------------------------
                                    count2winlevel4dragon = 0
                                    while 1:
                                        index2winlevel4dragon=str.find(search2level4dragon,winpattern2level4dragon)    
                                        if index2winlevel4dragon == -1:
                                            break
                                        else:
                                            search2level4dragon = search2level4dragon[0:index2winlevel4dragon] + webpattern2level4dragon + search2level4dragon[index2winlevel4dragon+len2winpattern4dragon:]
                                            if ack2debug4dragon is True:        
                                                print ('(STEP 6E/33) OF VERIFY2REF4DRAGON - MODIFIED SEARCH2LEVEL4DRAGON: ', search2level4dragon)
                                                # 
                                            count2winlevel4dragon = count2winlevel4dragon + 1
                                            if count2winlevel4dragon > 33:
                                                break 
                                                
                                    path2uri4dragon = search2level4dragon # save it !            
                                    # ----------------------------------------------------------------------
                                    # COUNT THE NUMBER OF LEVELS IN URI
                                    # ----------------------------------------------------------------------               
                                    count2level4dragon = 0
                                    while 1:
                                        index2weblevel4dragon=str.find(search2level4dragon,webpattern2level4dragon)
                                        if ack2debug4dragon is True:
                                            print ('(STEP 6F/33) OF VERIFY2REF4DRAGON - INDEX2WEBLEVEL4DRAGON: ', index2weblevel4dragon)
                                            # oneup:   2,7,4,11,5-1
                                            # norarts: 2
                                            # 
                                        if index2weblevel4dragon == -1:
                                            break 
                                        else:    
                                            count2level4dragon = count2level4dragon + 1
                                            if count2level4dragon > 33:
                                                break
                                            if ack2debug4dragon is True:
                                                print ('(STEP 6G/33) OF VERIFY2REF4DRAGON - COUNT2LEVEL4DRAGON: ', count2level4dragon)
                                                # norarts: 1
                                            try:    
                                                # =====================================================================================    
                                                search2level4dragon = search2level4dragon[index2weblevel4dragon+len2webpattern4dragon:]
                                                # ===================================================================================== 
                                                if ack2debug4dragon is True:
                                                    print ('(STEP 6H/33) OF VERIFY2REF4DRAGON - UPDATED SEARCH2LEVEL4DRAGON: ', search2level4dragon)
                                                    # oneup: : final result = index-sense-xi2.html OK
                                                    # eriarts: final result = index-arts-xi2.html  OK
                                                    # norarts: final result = en-ro-arts-xi2.html  OK
                                            except:                                                   
                                                print ('(STEP 6Z1/33) OF VERIFY2REF4DRAGON *** FAILED TO UPDATE SEARCH2LEVEL4DRAGON  FOR LINE: ', line2check4dragon)
                                                #  
                                                break  
                                    if ack2debug4dragon is True:        
                                        print ('(STEP 6I/33) OF VERIFY2REF4DRAGON - FINAL COUNT2LEVEL4DRAGON: ', count2level4dragon)
                                        # oneup:   5
                                        # eriarts: 6
                                        # norarts: 8    
                                else:
                                    pass
                            except:
                                print ('(STEP 6Z2/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE HYPERLINK REFERRED BY LINE2CHECK4DRAGON: ', line2check4dragon)
                                #
                                  
                            # ======================================================================
                            # RELATIVE - INDEX2STOP4DRAGON  
                            # ======================================================================
                            # line2check4dragon:
                            #   oneup:   <td><b>&laquo;</b><a href="../index.html" target="_blank"><b>&Theta;</b> HOME</a></td>
                            #   norarts: <td><b>&laquo;</b><a href="../../index-arts-xi2.html" target="_blank">Arts</a></td>
                            #   eriarts: <br /><b>&raquo;</b><a href="../../sense/arts/us/en-us-arts-xi2.html" target="_blank">The United States Arts Sensing</a>    
                            #
                            # target2explore4dragon: 
                            # oneup:   F://temp//yosense//test2dragon//sense//index-sense-xi2.html
                            # norarts: F://temp//yosense//test2dragon//sense//arts//ro//en//en-ro-arts-xi2.html
                            # eriarts: F://temp//yosense//test2dragon//sense//arts//index-arts-xi2.html
                            
                            index2stop4dragon = count2level4dragon - count2relative4dragon - 1                          
                            if ack2debug4dragon is True:
                                print ('(STEP 7C3/33) OF VERIFY2REF4DRAGON - INDEX2STOP4DRAGON: ', index2stop4dragon, ' = ', count2level4dragon, '(count2level4dragon) - ', count2relative4dragon, '(count2relative4dragon) - 1')
                                #                (count2level4dragon=//)  (count2relative4dragon), where relative
                                # oneup:    3  =         5                    -  1               - 1     ../
                                # norarts:  6  =         8                    -  1               - 1     ../../
                                # eriarts:  4  =         6                    -  1               - 1     ../../sense/
                                # 
                            search2level4dragon = path2uri4dragon
                            if ack2debug4dragon is True:
                                print ('(STEP 7D/33) OF VERIFY2REF4DRAGON - PATH2URI4DRAGON: ', path2uri4dragon)
                                # eriarts: F://temp//yosense//test2dragon//sense//arts//index-arts-xi2.html          OK
                                # norarts: F://temp//yosense//test2dragon//sense//arts//ro//en//en-ro-arts-xi2.html  
                                # oneup:   F://temp//yosense//test2dragon//sense//index-sense-xi2.html               OK
                            # ----------------------------------------------------------------------
                            # RELATIVE
                            # ----------------------------------------------------------------------           
                            index2final4dragon = 0 
                            path2open4dragon = None
                            if ack2debug4dragon is True:
                                print ('(STEP 7E/33) OF VERIFY2REF4DRAGON - INDEX2STOP4DRAGON: ', index2stop4dragon)
                                # eroarts: 4
                                # norarts: 6
                                # oneup:   3
                                # 
                            if index2stop4dragon > 0:
                                search2level4dragon = path2uri4dragon
                                if ack2debug4dragon is True:
                                    print ('(STEP 7F/33) OF VERIFY2REF4DRAGON - SEARCH2LEVEL4DRAGON: ', search2level4dragon)
                                    # eriarts: F://temp//yosense//test2dragon//sense//arts//index-arts-xi2.html         OK
                                    # norarts: F://temp//yosense//test2dragon//sense//arts//ro//en//en-ro-arts-xi2.html 
                                    # oneup:   F://temp//yosense//test2dragon//sense//index-sense-xi2.html              OK             
                                try:
                                    while 1:
                                        if count2relative4dragon == 0:
                                            break
                                        index2weblevel4dragon=str.find(search2level4dragon,webpattern2level4dragon)
                                        if index2weblevel4dragon == -1:
                                            break
                                        else:
                                            index2final4dragon = index2final4dragon + 1
                                            if index2final4dragon > 33:
                                                break
                                            if index2final4dragon == index2stop4dragon:
                                                try:
                                                    # ----------------------------------------------------------------------
                                                    # 
                                                    # ----------------------------------------------------------------------
                                                    count2ultimate4dragon = 0
                                                    search2webultimate4dragon = path2uri4dragon
                                                    if ack2debug4dragon is True:
                                                       print ('(STEP 8A/33) OF VERIFY2REF4DRAGON - SEARCH2WEBULTIMATE4DRAGON: ', search2webultimate4dragon)
                                                       # eriarts; F://temp//yosense//test2dragon//sense//arts//index-arts-xi2.html
                                                       # norarts: F://temp//yosense//test2dragon//sense//arts//ro//en//en-ro-arts-xi2.html 
                                                       # oneup:   F://temp//yosense//test2dragon//sense//index-sense-xi2.html
                                                       #  
                                                    begin2ultimate4dragon = ''
                                                    while 1:
                                                        index2webultimate4dragon=str.find(search2webultimate4dragon,webpattern2level4dragon)
                                                        if index2webultimate4dragon == -1:
                                                            break
                                                        else:    
                                                            # =====================================================================================================
                                                            begin2ultimate4dragon = begin2ultimate4dragon + search2webultimate4dragon[0:index2webultimate4dragon+len(webpattern2level4dragon)]
                                                            # =====================================================================================================
                                                            if ack2debug4dragon is True:
                                                                print ('(STEP 8B/33) OF VERIFY2REF4DRAGON - BEGIN2ULTIMATE4DRAGON: ', begin2ultimate4dragon)
                                                                # eriarts: 0 F://
                                                                #          1 F://temp/
                                                                #          2 F://temp//yosense//
                                                                #          3 F://temp//yosense//test2dragon//
                                                                #          4 F://temp//yosense//test2dragon//sense//
                                                                #          5 goto 8C2
                                                                # norarts:
                                                                #          0 F://
                                                                #          1 F://temp//
                                                                # ...
                                                                #          6 F://temp//yosense//test2dragon//sense//arts//ro//
                                                                #          7 goto 8C3
                                                                # oneup:   0 F://
                                                                #          1
                                                                # ...         
                                                                #          4 F://temp//yosense//test2dragon//      
                                                                #          5 goto 8C3
                                                                
                                                            count2ultimate4dragon = count2ultimate4dragon  + 1
                                                            if ack2debug4dragon is True:
                                                                print ('(STEP 8C0/33) OF VERIFY2REF4DRAGON - COUNT2ULTIMATE4DRAGON: ', count2ultimate4dragon)
                                                                # eriarts: 1...5
                                                            if count2ultimate4dragon > 33:
                                                                break
                                                            if count2ultimate4dragon > index2stop4dragon:
                                                                try:
                                                                    if ack2abnormal4dragon is True:
                                                                        begin2ultimate4dragon = begin2ultimate4dragon
                                                                        if ack2debug4dragon is True:
                                                                            print ('(STEP 8C2/33) OF VERIFY2REF4DRAGON - BEGIN2ULTIMATE4DRAGON: ', begin2ultimate4dragon)
                                                                            # eriarts: F://temp//yosense//test2dragon//sense//
                                                                            # 
                                                                    else:
                                                                        if ack2debug4dragon is True:
                                                                            print ('(STEP 8C3/33) OF VERIFY2REF4DRAGON - BEGIN2ULTIMATE4DRAGON: ', begin2ultimate4dragon)
                                                                            # norarts: F://temp//yosense//test2dragon//sense//arts//ro// 
                                                                            # oneup:   F://temp//yosense//test2dragon//
                                                                            # 
                                                                    
                                                                    # =====================================================================================================
                                                                    path2open4dragon = begin2ultimate4dragon + down2ultimate4dragon + rest2check4dragon             
                                                                    # =====================================================================================================
                                                                    if ack2debug4dragon is True:
                                                                        print ('(STEP 8D30/33) OF VERIFY2REF4DRAGON - PATH2OPEN4DRAGON ', path2open4dragon)
                                                                        print ('(STEP 8D31/33) OF VERIFY2REF4DRAGON - BEGIN2ULTIMATE4DRAGON ', begin2ultimate4dragon)
                                                                        print ('(STEP 8D32/33) OF VERIFY2REF4DRAGON - DOWN2ULTIMATE4DRAGON', down2ultimate4dragon)
                                                                        print ('(STEP 8D33/33) OF VERIFY2REF4DRAGON - REST2CHECK4DRAGON ', rest2check4dragon)
                                                                        # eriarts: F://temp//yosense//test2dragon//sense//arts/us/en-us-arts-xi2.html
                                                                        #          F://temp//yosense//test2dragon//sense//
                                                                        #          arts/us/
                                                                        #          en-us-arts-xi2.html
                                                                        #          LINE2CHECK4DRAGON  <br /><b>&raquo;</b><a href="../../sense/arts/us/en-us-arts-xi2.html" target="_blank">The United States Arts Sensing</a>
                                                                        # oneup:   F://temp//yosense//test2dragon//index.html
                                                                        #          F://temp//yosense//test2dragon//
                                                                        #          
                                                                        #          index.html
                                                                        #          <td><b>&laquo;</b><a href="../index.html" target="_blank"><b>&Theta;</b> HOME</a></td>
                                                                        # norarts: 
                                                                        #          
                                                                        #          
                                                                        #          
                                                                        #          
                                                                    break
                                                                except:
                                                                    print ('(STEP 8Z6/33) OF VERIFY2REF4DRAGON - PATH2OPEN4DRAGON: ', path2open4dragon)
                                                                    #
                                                                    break              
                                                            else:
                                                                search2webultimate4dragon = search2webultimate4dragon[index2webultimate4dragon+2:]     
                                                                if ack2debug4dragon is True:
                                                                    print ('(STEP 8E/33) OF VERIFY2REF4DRAGON - UPDATED SEARCH2ULTIMATE4DRAGON: ', search2webultimate4dragon)
                                                                    # 
                                                        pass            
                                                except:
                                                    print ('(STEP 8Z7/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE HYPERLINK REFERRED BY PATH2OPEN4DRAGON: ', path2open4dragon)
                                                    #            
                                                    break    
                                            else:
                                                try:
                                                    search2level4dragon = search2level4dragon[index2weblevel4dragon+len2webpattern4dragon:]
                                                    # 
                                                except:
                                                    print ('(STEP 8Z8/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE HYPERLINK REFERRED BY PATH2URI4DRAGON: ', path2uri4dragon)
                                                    #            
                                                    break
                                except:
                                    print ('(STEP 6Z9/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE HYPERLINK REFERRED BY LINE2CHECK4DRAGON: ', line2check4dragon)
                                    #              
                            else:
                                print ('(STEP 6Z10/33) OF VERIFY2REF4DRAGON *** FAILED TO CREATE HYPERLINK - INDEX2STOP4DRAGON: ', index2stop4dragon)
                                #
                            

                            # ----------------------------------------------------------------------------
                            # RELATIVE - OPEN AND CLOSE HTML FILE REFERRED THEREBY VERIFYING ITS EXISTENCE
                            # ----------------------------------------------------------------------------         
                            if ack2debug4dragon is True:
                                print ('(STEP 30A/33) OF VERIFY2REF4DRAGON - TRYING TO OPEN AND CLOSE HYPERLINK HTML FILE REFERRED BY LINE2CHECK4DRAGON ', line2check4dragon)
                                # 
                            try:    
                                fileobject2verify4dragon = open(path2open4dragon,'r')
                                if ack2debug4dragon is True:
                                    print ('(STEP 30B/33) OF VERIFY2REF4DRAGON - OPENED FILEOBJECT2VERIFY4DRAGON : ', fileobject2verify4dragon)
                                    # 
                                    
                                fileobject2verify4dragon.close()
                                if ack2debug4dragon is True:
                                    print ('(STEP 30C/33) OF VERIFY2REF4DRAGON - CLOSED FILEOBJECT2VERIFY4DRAGON : ', fileobject2verify4dragon)
                                    # 
                                     
                                if ack2uricheck4dragon is True:    
                                    try:
                                        # ---------------------------------------------------------------------------------------------------
                                        # REPORT URI (NOT AS HYPERLINK)
                                        # ---------------------------------------------------------------------------------------------------    
                                        line2write4dragon = '<br />' + '[URI]: ' + str(path2open4dragon) + ' [ACK] ' + ' \n'
                                        fileobject2stat4dragon.write(line2write4dragon)
                                        count2ackuri4dragon = count2ackuri4dragon + 1
                                        total2ackuri4dragon = total2ackuri4dragon + 1
                                    except:
                                        print ('(STEP 30Z1/33) OF VERIFY2REF4DRAGON - *** FAILED TO WRITE WITH FILEOBJECT2STAT4DRAGON ***')        
                            except:
                                print ('****************************************************************************************************************************************************************')
                                print ('(STEP 30Z2/33) OF VERIFY2REF4DRAGON *** FAILED TO OPEN PATH2OPEN4DRAGON : ', path2open4dragon)
                                print ('****************************************************************************************************************************************************************')
                                 
                                try:
                                    pattern2xx4dragon = '//xx//'
                                    index2xx4dragon=str.find(path2open4dragon,pattern2xx4dragon)
                                    if index2xx4dragon == -1:
                                        # ---------------------------------------------------------------------------------------------------
                                        # REPORT URI (NOT AS HYPERLINK)
                                        # ---------------------------------------------------------------------------------------------------  
                                        line2write4dragon = '<br />' + '[URI]: ' + path2open4dragon + '</a>' + ' [NACK] LINE ' + line2check4dragon + ' \n'
                                        fileobject2stat4dragon.write(line2write4dragon)
                                        count2nackuri4dragon = count2nackuri4dragon + 1
                                        total2nackuri4dragon = total2nackuri4dragon + 1 
                                    else:
                                        line2write4dragon = '<br />' + '[URI]: ' + path2open4dragon + '</a>' + ' [NACK] LINE ' + line2check4dragon + ' \n'
                                        fileobject2stat4dragon.write(line2write4dragon)
                                        count2nackuri4dragon = count2nackuri4dragon + 1
                                        total2nackuri4dragon = total2nackuri4dragon + 1    
                                except:
                                    print ('(STEP 30Z3/33) OF VERIFY2REF4DRAGON - *** FAILED TO WRITE WITH FILEOBJECT2STAT4DRAGON ***') 
                            # ----------------------------------------------------------------------
                            # EOF RELATIVE URI PROCESSING)
                            # ----------------------------------------------------------------------            
                        # ------------------------------------------------------------------------- 
                        # LINE VERIFIED
                        # -------------------------------------------------------------------------                  
                    # -----------------------------------------------------------------------------
                    # EOF LINES TO BE VERIFIED
                    # -----------------------------------------------------------------------------                
            # -------------------------------------------------------------------------------------
            # FILE VERIFIED
            # -------------------------------------------------------------------------------------
            
        # -------------------------------------------------------------------------------------
        # CLOSE FILE
        # -------------------------------------------------------------------------------------    
        if ack2debug4dragon is True:
            print ('(STEP 31A/33) OF VERIFY2REF4DRAGON - TARGET2EXPLORE4DRAGON: ', target2explore4dragon)
            print ('(STEP 31B/33) OF VERIFY2REF4DRAGON - COUNT2PASSED4DRAGON: ', count2passed4dragon)
            print ('(STEP 31C/33) OF VERIFY2REF4DRAGON - COUNT2FOUND4DRAGON: ', count2found4dragon)
            
        fileobject2target4dragon.close()
        if ack2debug4dragon is True:
            print ('(STEP 32A/33) OF VERIFY2REF4DRAGON - CLOSED FILEOBJECT4DRAGON: ', fileobject2target4dragon)
            #                                     
    else:
        # -------------------------------------------------------------------------------------
        # FILE SKIPPED
        # -------------------------------------------------------------------------------------
        if ack2debug4dragon is True:
            print ('(STEP 10A/33) OF VERIFY2REF4DRAGON - SKIPPED FILE: ', target2explore4dragon)
            # 

    # ---------------------------------------------------------------
    # STATISTICS 
    # ---------------------------------------------------------------    
    try:
        if ack2uricheck4dragon is True:
            try:
                if count2ackuri4dragon > 0:
                    line2write4dragon = '<br />' +  '<b>&Sigma;</b>' + '[URI]: ' + str(count2ackuri4dragon) + ' [ACK]' + ' \n'
                    fileobject2stat4dragon.write(line2write4dragon)
                if count2nackuri4dragon > 0:    
                    line2write4dragon = '<br />' +  '<b>&Sigma;</b>' + '[URI]: ' + str(count2nackuri4dragon) + ' [NACK] *** ' + ' \n'
                    fileobject2stat4dragon.write(line2write4dragon)
            except:
                print ('(STEP 33Z1/33) OF VERIFY2REF4DRAGON *** FAILED TO PRINT URI STATISTICS ', time4xi())
                #
        if ack2urltest4dragon is True:    
            try:
                if count2ackurl4dragon > 0:
                    line2write4dragon = '<br />' +  '<b>&Sigma;</b>' + '[URL]: ' + str(count2ackurl4dragon) + ' [ACK]' + ' \n'
                    fileobject2stat4dragon.write(line2write4dragon)
                if count2nackurl4dragon > 0:    
                    line2write4dragon = '<br />' +  '<b>&Sigma;</b>' + '[URL]: ' + str(count2nackurl4dragon) + ' [NACK] *** ' + ' \n'
                    fileobject2stat4dragon.write(line2write4dragon)

            except:
                print ('(STEP 33Z2/33) OF VERIFY2REF4DRAGON *** FAILED TO PRINT URL STATISTICS ', time4xi())
                #            
    except:
        print ('(STEP 33Z3/33) OF VERIFY2REF4DRAGON *** FAILED TO PRINT STATISTICS ', time4xi())
        #
    if ack2debug4dragon is True:
        print ('(STEP 33/33) OF VERIFY2REF4DRAGON - RETURNING ', time4xi())
        # 
        print ('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
    # ---------------------------------------------------------------
    # RETURN
    # ---------------------------------------------------------------                         
    return
                
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2dragon4uri" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2dragon4uri(queue2dragon = None, consumer_channel2dragon = None, publisher_channel2dragon = None, path2dragon = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global ack2debug4dragon
    
    global count2ackuri4dragon
    global count2nackuri4dragon
    global count2ackurl4dragon
    global count2nackurl4dragon
        
    global count2found4dragon
    global count2passed4dragon

    global fileobject2stat4dragon
    
    global kbfocus2uri4dragon
    global keys2focus2uri4dragon
       
    global profile2fetch4dragon
    
    global keys2profile4dragon
    global key2profile4dragon

    global total2ackuri4dragon
    global total2nackuri4dragon
    global total2ackurl4dragon
    global total2nackurl4dragon    
    
            
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2DRAGON4URI - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2DRAGON4URI -  QUEUE2DRAGON: ", queue2dragon)      
    # 
    print("(STEP 0C/33) OF SHOOT2DRAGON4URI -  CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon)
    # 
    print("(STEP 0D/33) OF SHOOT2DRAGON4URI -  PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)          
    # 

    if ((queue2dragon is None) or (consumer_channel2dragon is None) or (publisher_channel2dragon is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        if ack2debug4dragon is True:
            print("(STEP 1A/33) OF SHOOT2DRAGON4URI - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
            print("(STEP 1B/33) OF SHOOT2DRAGON4URI - QUEUE2DRAGON: ", queue2dragon)
            print("(STEP 1C/33) OF SHOOT2DRAGON4URI - CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon) 
            print("(STEP 1D/33) OF SHOOT2DRAGON4URI - PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)
            print("(STEP 1E/33) OF SHOOT2DRAGON4URI - PATH2DRAGON: ", path2dragon)     
        
        print("(STEP 1F/33) OF SHOOT2DRAGON4URI -  RETURNING ", time4xi())          
        #     
            
        return
 
    if (not (queue2dragon is None) and not(consumer_channel2dragon is None) and not(publisher_channel2dragon is None) and (path2dragon is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        if ack2debug4dragon is True:
            print("(STEP 2A/33) OF SHOOT2DRAGON4URI - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
            print("(STEP 2B/33) OF SHOOT2DRAGON4URI - QUEUE2DRAGON: ", queue2dragon)
            print("(STEP 2C/33) OF SHOOT2DRAGON4URI - CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon) 
            print("(STEP 2D/33) OF SHOOT2DRAGON4URI - PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)
            print("(STEP 2E/33) OF SHOOT2DRAGON4URI - PATH2DRAGON: ", path2dragon) 
            
        print("(STEP 2F/33) OF SHOOT2DRAGON4URI -  RETURNING ", time4xi())          
        #            
        return           

    if (not (queue2dragon is None) and not(consumer_channel2dragon is None) and not(publisher_channel2dragon is None) and not(path2dragon is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        if ack2debug4dragon is True:
            print("(STEP 3A/33) OF SHOOT2DRAGON4URI - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
            # 
            print("(STEP 3B/33) OF SHOOT2DRAGON4URI - QUEUE2DRAGON: ", queue2dragon)
            # 
            print("(STEP 3C/33) OF SHOOT2DRAGON4URI - CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon)
            # 
            print("(STEP 3D/33) OF SHOOT2DRAGON4URI - PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)
            # 
            print("(STEP 3E/33) OF SHOOT2DRAGON4URI - PATH2DRAGON: ", path2dragon)
            # 
           
            print("(STEP 3F/33) OF SHOOT2DRAGON4URI - STARTING TO WALK PATH2DRAGON: ", path2dragon)   
            # 
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4dragon = None
        name2index4dragon = "uri2dragon4yo.html"
        id2your4dragon      = "dragon"
        
        
        path2index4dragon = path2dragon + name2index4dragon
        if ack2debug4dragon is True:
            print("(Step 4A/33) OF SHOOT2DRAGON4URI - SET PATH2INDEX4DRAGON TO: ", path2index4dragon)
            # 
        try:
            fileobject2stat4dragon = open(path2index4dragon,'w')
            print("(Step 4B/33) OF SHOOT2DRAGON4URI - OPENED OUTPUT: ", fileobject2stat4dragon)
            # 
        except:
            print("(Step 4Z1/33) OF SHOOT2DRAGON4URI *** FAILED TO OPEN OUTPUT: ", fileobject2stat4dragon, ' FOR PATH2INDEX4DRAGON ' , path2index4dragon)         
            #                 
        try:                
            fileobject2stat4dragon.write('<html>\n')
            fileobject2stat4dragon.write('<style type="text/css" media="all">\n')
            fileobject2stat4dragon.write(' @import "https://www.yourdragonxi.org/css/halongbay.css";\n')
            fileobject2stat4dragon.write('</style> \n')
            fileobject2stat4dragon.write('<p>\n')
            fileobject2stat4dragon.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject2stat4dragon.write('<br /><a id="000">' + id2your4dragon + '<b>&Xi;</b> @URI</a>\n')
            fileobject2stat4dragon.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject2stat4dragon.write('<br /> \n')
        except:
            print("(Step 4Z2/33) OF SHOOT2DRAGON4URI *** FAILED TO WRITE BEGIN OF OUTPUT: ", fileobject2stat4dragon)         
            #
            
        try:
            line2write4dragon = '<br />' + '<b>' + ' Domains: ' + '</b>'+ ' \n'
            fileobject2stat4dragon.write(line2write4dragon) 
            
            for key2domain2uri4dragon in sorted(keys2domain2uri4dragon):    
                if ack2debug4dragon is True:
                    print("(Step 4C/33) OF SHOOT2DRAGON4URI - KBDOMAIN2URI4DRAGON[", key2domain2uri4dragon, '] ', kbdomain2uri4dragon[key2domain2uri4dragon])
                    # 
                ack2focus4dragon = False    
                for key2focus2uri4dragon in keys2focus2uri4dragon:
                    if kbfocus2uri4dragon[key2focus2uri4dragon] == kbdomain2uri4dragon[key2domain2uri4dragon]:
                        ack2focus4dragon = True
                    else:
                        pass            
                if ack2focus4dragon is False:    
                    line2write4dragon = '<br />' +  kbdomain2uri4dragon[key2domain2uri4dragon] + ' \n'
                    fileobject2stat4dragon.write(line2write4dragon)
                else:
                    line2write4dragon = '<br />' + '<b>' +  kbdomain2uri4dragon[key2domain2uri4dragon] + ' <-- to be verified! ' + '</b>' + ' \n'
                    fileobject2stat4dragon.write(line2write4dragon)    
                    
        except:
            print("(Step 4Z3/33) OF SHOOT2DRAGON4URI *** FAILED TO TELL DOMAINS ***")         
            # 
            
        # =====================================================================
        # SITE VERIFICATION   
        # =====================================================================              
        for file2walk in DirectoryWalker(path2dragon):
            # ----------------------------------------
            # WALK
            # ----------------------------------------     
            if os.path.isdir(file2walk):
                # ------------------------------------
                # DIRECTORY LEVEL - NO OPERATIONS
                # ------------------------------------
                pass     
            else:
                # ------------------------------------
                # FILE LEVEL OPERATION - VERIFY IT
                # ------------------------------------
                try:
                    for key2domain2uri4dragon in keys2domain2uri4dragon:
                        pattern2focus4dragon = path2dragon + kbfocus2uri4dragon[key2domain2uri4dragon]
                        index2focus4dragon=str.find(file2walk,pattern2focus4dragon)
                        if index2focus4dragon == -1:
                            # ---------------------------------------------------------------------------
                            # NOT TESTED - IS ONLY TO BE REFERRED 
                            # ---------------------------------------------------------------------------
                            pass
                        else:
                            # ---------------------------------------------------------------------------
                            # VERIFY FILE
                            # ---------------------------------------------------------------------------    
                            verify2ref4dragon(file2walk)
                except:
                    # print("(Step 4Z4/33) OF SHOOT2DRAGON4URI *** FAILED IN VERIFYING FILE : ", file2walk)         
                    #
                    pass   
                
     
        # ---------------------------------------------------------------
        # TOTAL STATISTICS 
        # ---------------------------------------------------------------    
        try:
            line2write4dragon = '<br />' +  '=====================' + ' \n'
            fileobject2stat4dragon.write(line2write4dragon)
            line2write4dragon = '<br />' +  'TOTAL STATISTICS' + ' \n'
            fileobject2stat4dragon.write(line2write4dragon)
            line2write4dragon = '<br />' +  '---------------------------------' + ' \n'
            fileobject2stat4dragon.write(line2write4dragon)
            try:
                line2write4dragon = '<br />' +  '<b>&Sigma;</b>' + '[URI]: ' + str(total2ackuri4dragon) + ' [ACK]' + ' \n'
                fileobject2stat4dragon.write(line2write4dragon)
                line2write4dragon = '<br />' +  '<b>&Sigma;</b>' + '[URI]: ' + str(total2nackuri4dragon) + ' [NACK]' + ' \n'
                fileobject2stat4dragon.write(line2write4dragon)
            except:
                print ('(STEP 33Z1/33) OF SHOOT2DRAGON4URI *** FAILED TO PRINT URI STATISTICS ', time4xi())
                #
               
            try:
                line2write4dragon = '<br />' +  '---------------------------------' + ' \n'
                fileobject2stat4dragon.write(line2write4dragon) 
                line2write4dragon = '<br />' +  '<b>&Sigma;</b>' + '[URL]: ' + str(total2ackurl4dragon) + ' [ACK]' + ' \n'
                fileobject2stat4dragon.write(line2write4dragon)
                if total2nackurl4dragon > 0:
                    line2write4dragon = '<br />' +  '<b>&Sigma;</b>' + '[URL]: ' + str(total2nackurl4dragon) + ' [NACK] ***' + ' \n'
                else:
                    line2write4dragon = '<br />' +  '<b>&Sigma;</b>' + '[URL]: ' + str(total2nackurl4dragon) + ' [NACK] ' + ' \n'    
                fileobject2stat4dragon.write(line2write4dragon)
                line2write4dragon = '<br />' +  '=====================' + ' \n'
                fileobject2stat4dragon.write(line2write4dragon) 
            except:
                print ('(STEP 33Z2/33) OF SHOOT2DRAGON4URI *** FAILED TO PRINT URL STATISTICS ', time4xi())
                # 
                              
        except:
            print("(Step 33Z3/33) OF SHOOT2DRAGON4URI *** FAILED TO WRITE TOTAL STATISTICS ***")         
            #       
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject2stat4dragon.write('<br /> \n')
            fileobject2stat4dragon.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject2stat4dragon.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject2stat4dragon.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject2stat4dragon.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject2stat4dragon.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject2stat4dragon.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject2stat4dragon.write('</p>\n')
            # 
            fileobject2stat4dragon.write('</html>\n')
        except:
            print("(Step 33Z4/33) OF SHOOT2DRAGON4URI *** FAILED TO WRITE WITH FILEOBJECT2STAT4DRAGON ***")         
            #             
        try:    
            fileobject2stat4dragon.close()
            print("(Step 33A/33) OF SHOOT2DRAGON4URI - CLOSED OUTPUT: ", fileobject2stat4dragon)         
            #  
        except:
            print("(Step 33Z5/33) OF SHOOT2DRAGON4URI *** FAILED TO CLOSE OUTPUT: ", fileobject2stat4dragon)         
            #                  
                    
            
        print("(STEP 33B/33) OF SHOOT2DRAGON4URI - RETURNING NORMALLY ", time4xi())    
        # 
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2DRAGON4URI *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2DRAGON4URI - QUEUE2DRAGON: ", queue2dragon)
        print("(STEP 7Z3/33) OF SHOOT2DRAGON4URI - CONSUMER_CHANNEL2DRAGON: ", consumer_channel2dragon) 
        print("(STEP 7Z4/33) OF SHOOT2DRAGON4URI - PUBLISHER_CHANNEL2DRAGON: ", publisher_channel2dragon)
        print("(STEP 7Z5/33) OF SHOOT2DRAGON4URI - PATH2DRAGON: ", path2dragon)     
        
        try:    
            fileobject2stat4dragon.close()
            print("(Step 7Z6/33) OF SHOOT2DRAGON4URI - CLOSED OUTPUT: ", fileobject2stat4dragon)         
            #  
        except:
            print("(Step 7Z7/33) OF SHOOT2DRAGON4URI *** FAILED TO CLOSE OUTPUT: ", fileobject2stat4dragon)         
            #      
         
        print("(STEP 7Z8/33) OF SHOOT2DRAGON4URI *** RETURNING ABNORMALLY - UNEXPECTED PARAMETER COMBINATION ", time4xi())
        #     
          
             
        return  
    

            
    try:    
        fileobject2stat4dragon.close()
        print("(Step 33C2/33) OF SHOOT2DRAGON4URI - CLOSED OUTPUT: ", fileobject2stat4dragon)         
        #  
    except:
        print("(Step 33Z33/33) OF SHOOT2DRAGON4URI *** FAILED TO CLOSE OUTPUT: ", fileobject2stat4dragon)         
        #
             
         
    print("(STEP 33C/33) OF SHOOT2DRAGON4URI - RETURNING AT THE END ", time4xi())
    #  
                   
    return           
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# uri2dragon4yo.html
# ROOT4XI\Studio4Xi\Python\3.3\temp\automate2ref4uri.txt
# \xml\ace-automate2ref4uri.xml
# \xml\reason-automate2ref4uri.xml
# \xml\sense-automate2ref4uri.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2dragon4uri.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
